/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IMPRESSOOPER                                             */
/* Tabela : IMPRESSOOPER                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/06/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_IMPRESSOOPER'and
             type = 'TR'                     and
             u.uid = o.uid                   and
             u.name = USER)
   DROP TRIGGER DTULTATU_IMPRESSOOPER
GO

CREATE TRIGGER DTULTATU_IMPRESSOOPER
ON IMPRESSOOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'IMPRESSOOPER', NULL, 'CDIMPRESSORA=' + CDIMPRESSORA + ';' +
                                                            'NROPERIMPR='+ NROPERIMPR + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);
   END
   ELSE BEGIN
      UPDATE IMPRESSOOPER
      SET DTULTATUIMOP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(IMPRESSOOPER.CDIMPRESSORA,0) = ISNULL(INSERTED.CDIMPRESSORA,0))AND
            (ISNULL(IMPRESSOOPER.NROPERIMPR,0)= ISNULL(INSERTED.NROPERIMPR,0));
   END;
END;
GO

UPDATE IMPRESSOOPER SET DTULTATUIMOP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUIMOP IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUIMOP' and
            type = 'D')
   ALTER TABLE IMPRESSOOPER DROP CONSTRAINT DEFAULT_DTULTATUIMOP
GO

ALTER TABLE IMPRESSOOPER ADD CONSTRAINT DEFAULT_DTULTATUIMOP
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUIMOP
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_IMPRESSOOPER','4.11.194';
GO

