ALTER TABLE CADASTROPROJETO ADD IDSUBPROJETO VARCHAR2(1) DEFAULT 'N'
/

ALTER TABLE CADASTROPROJETO ADD CONSTRAINT CKC_IDSUBPROJETO_PROJETO CHECK (IDSUBPROJETO IN ('S', 'N'))
/

CREATE TABLE PROJETOLOCAL
(
    IDPROJETOLOCAL VARCHAR2(10) NOT NULL,
    CDPROJETO       VARCHAR2(3)     NOT NULL,
    CDFILIAL        VARCHAR2(4)     NOT NULL,
    CDSUBPROJETO    VARCHAR2(3)     DEFAULT NULL,
    NRORG           NUMBER          DEFAULT   SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO         VARCHAR2(1)     DEFAULT 'S'   NOT NULL
      CONSTRAINT CKC_IDATIVO_PROJETOLOCAL CHECK (IDATIVO IN ('S', 'N')),          
    DTINCLUSAO      DATE            NULL,
    DTULTATU        DATE            NULL,
    NRORGINCLUSAO   NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERINCLUSAO  VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERULTATU    VARCHAR2(12)    DEFAULT '1' NULL,
        CONSTRAINT PK_PROJETOLOCAL PRIMARY KEY (IDPROJETOLOCAL, CDPROJETO, CDFILIAL)
 
)
/

CREATE INDEX VND00805_FK ON PROJETOLOCAL (CDPROJETO ASC)
/ 

ALTER TABLE PROJETOLOCAL
   ADD CONSTRAINT FKVND00805CADASTROPROJETO FOREIGN KEY (CDPROJETO)
      REFERENCES CADASTROPROJETO (CDPROJETO)
/

CREATE INDEX VND00806_FK ON PROJETOLOCAL (CDFILIAL ASC)
/ 

ALTER TABLE PROJETOLOCAL
   ADD CONSTRAINT FKVND00806FILIAL FOREIGN KEY (CDFILIAL)
      REFERENCES FILIAL (CDFILIAL)
/

CREATE TABLE LISTAEMAILTECLOCAL
(
    CDPROJETO       VARCHAR2(3)     NOT NULL,
    CDFILIAL        VARCHAR2(4)     NOT NULL,
    CDEMAILTEC      VARCHAR2(4)     NOT NULL,
    DSEMAILTEC      VARCHAR2(64)    NOT NULL,
    CDSUBPROJETO    VARCHAR2(3)     DEFAULT NULL,
    NRORG           NUMBER          DEFAULT   SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO         VARCHAR2(1)     DEFAULT 'S'   NOT NULL
      CONSTRAINT CKC_IDATIVO_LISTAEMAILTECLOCAL CHECK (IDATIVO IN ('S', 'N')),          
    DTINCLUSAO      DATE            NULL,
    DTULTATU        DATE            NULL,
    NRORGINCLUSAO   NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERINCLUSAO  VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERULTATU    VARCHAR2(12)    DEFAULT '1' NULL,
        CONSTRAINT PK_LISTAEMAILTECLOCAL PRIMARY KEY (CDPROJETO, CDEMAILTEC)
)
/

CREATE INDEX VND00807_FK ON LISTAEMAILTECLOCAL (CDPROJETO ASC)
/

ALTER TABLE LISTAEMAILTECLOCAL
   ADD CONSTRAINT FKVND00807CADASTROPROJETO FOREIGN KEY (CDPROJETO)
      REFERENCES CADASTROPROJETO (CDPROJETO)
/

CREATE INDEX VND00808_FK ON LISTAEMAILTECLOCAL (CDFILIAL ASC)
/

ALTER TABLE LISTAEMAILTECLOCAL
   ADD CONSTRAINT FKVND00808FILIAL FOREIGN KEY (CDFILIAL)
      REFERENCES FILIAL (CDFILIAL)
/