package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AlergenicoProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaAlergenicosProduto = By.xpath("//span[text() = 'Alergênicos do Produto']");

    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By produtoCineraria = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CINERARIA MARITIMA  PLANTA INTEIRA']");
    By prodTelaIniCarnobanoMagnesio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARBONATO DE MAGNESIO']");
    By prodTelaIniCarnobanoMagnesio500 = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARBONATO DE MAGNESIO 500G']");

    By botaoCadastroAutomatico = By.xpath("//div[@class=\"zh-footer-right\"]");
    By campoOperacao = By.xpath("//div[@data-zh-id=\"1755880832488997424503\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By botaoProdutoInicial = By.xpath("//div[@id=\"NMPRODI\"]//span[@style=\"background-image: none; display: block;\"]");
    By operacaoIncluir = By.xpath("//div[@data-zh-id=\"1755880832488997424503\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Incluir']");
    By operacaoExcluir = By.xpath("//div[@data-zh-id=\"1755880832488997424503\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Excluir']");
    By botaoProdutoFinal = By.xpath("//div[@id=\"NMPRODF\"]//span[@style=\"background-image: none; display: block;\"]");
    By produtoCarbonatoMagnesio = By.xpath("//section[@class=\"popup-content\"]//div[@data-zh-field-name=\"CDARVPROD\"]//span[text() = '1.01.1.1.02.006.00']");
    By produtoCarbonatoMagnesio500 = By.xpath("//section[@class=\"popup-content\"]//div[@data-zh-field-name=\"CDARVPROD\"]//span[text() = '1.01.1.1.02.006.01']");
    By campoAlergenicos = By.id("NMALERGENICO");
    By alerAmendoim = By.xpath("//div[@data-zh-field-name=\"NMALERGENICO\"]//span[text() = 'AMENDOIM']");
    By alerMolusco = By.xpath("//div[@data-zh-field-name=\"NMALERGENICO\"]//span[text() = 'MOLUSCO']");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By botaoSalvar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By checkBoxAlergenicoAmendoim = By.xpath("//div[@id=\"grid-175588083276679992311\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By checkBoxAlergenicoMolusco = By.xpath("//div[@id=\"grid-175588083276679992311\"]//div[@class=\"body-content\"]/div[3]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By checkBoxAlergenicoCrustaceo = By.xpath("//div[@id=\"grid-175588083276679992311\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");

    By mensagemNaoHaRegistroTelaAler = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoSimAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoDeOpcoesDaTela = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");

    By checkBoxTodosAlergenicos = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"header-content\"]//div[@class=\"zh-theader zh-ripple-effect\"]");
    By nomeAlergenicoCabecalho = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"NMALERGENICO\"]");
    By listaAlergenicosProd = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]/div");
    By checkBoxAlergenico1 = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By nomeAlergenico1 = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By siglaAlergenico1 = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By nomeAlergenico2 = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By siglaAlergenico2 = By.xpath("//div[@id=\"grid-17558808323467076426310\"]//div[@class=\"body-content\"]/div[2]/div[3]/span");

    By campoObrigatorioAlergicosCadAuto = By.xpath("//div[@data-zh-id=\"17558808324055201064504\"]//div[@class=\"zh-validation\"]/span");
    By campoObrigatorioProdInicialCadAuto = By.xpath("//div[@data-zh-id=\"175588083240884251509\"]//div[@class=\"zh-validation\"]/span");
    By campoObrigatorioProdFinalCadAuto = By.xpath("//div[@data-zh-id=\"17558808324014341669512\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Alergênicos do Produto");
        click(opcaoTelaAlergenicosProduto);
    }

    public void selecionarProduto() {
        preencherCampoProcurarTelaInicial("CINERARIA MARITIMA  PLANTA INTEIRA");
        click(produtoCineraria);
    }

    public void addAlergenicos() {
        click(botaoAdicionar);
        click(checkBoxAlergenicoAmendoim);
        click(checkBoxAlergenicoMolusco);
        click(botaoSalvar);
    }

    public void verificarAlergenicosAdd() {
        tempo();
        click(nomeAlergenicoCabecalho);
        tempo();
        String expNome = "AMENDOIM";
        String expSigla = "AM";
        String nome = getText(nomeAlergenico1);
        String sigla = getText(siglaAlergenico1);
        Assert.assertEquals(nome, expNome, "Verificação do nome do primeiro alergênico adicionado");
        Assert.assertEquals(sigla, expSigla, "Verificação da sigla do primeiro alergênico adicionado");

        expNome = "MOLUSCO";
        expSigla = "MOL";
        sigla = getText(siglaAlergenico2);
        nome = getText(nomeAlergenico2);
        Assert.assertEquals(nome, expNome, "Verificação do nome do segundo alergênico adicionado");
        Assert.assertEquals(sigla, expSigla, "Verificação da sigla do segundo alergênico adicionado");
        click(nomeAlergenicoCabecalho);
        click(nomeAlergenicoCabecalho);
    }

    public void adicionarCrustaceo() {
        click(botaoAdicionar);
        click(checkBoxAlergenicoCrustaceo);
        click(botaoSalvar);
        tempo();
        click(nomeAlergenicoCabecalho);
        verificarAlergenicosCadManual();

        String expNome = "CRUSTÁCEO";
        String expSigla = "CRUS";
        String nome = getText(nomeAlergenico2);
        String sigla = getText(siglaAlergenico2);
        Assert.assertEquals(nome, expNome, "Verificação do nome do terceiro alergênico adicionado");
        Assert.assertEquals(sigla, expSigla, "Verificação da sigla do terceiro alergênico adicionado");
    }

    public void excluirAlergenico() {
        tempo();
        tempo();
        click(checkBoxAlergenico1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida após tentar excluir um alergênico");
        click(botaoSimAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de sucesso, após exclusão do alergênico");

    }

    public void excluirTodosAlergenicos() {
        tempo();
        tempo();
        click(checkBoxTodosAlergenicos);
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida após tentar excluir um alergênico");
        click(botaoSimAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de sucesso, após exclusão do alergênico");

        mensagem = getText(mensagemNaoHaRegistroTelaAler);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de não há registros, após a exclusão de todos os alergênicos do produto");
    }

    public void preencherFormCadAutomaticoInclusao() {
        click(botaoCadastroAutomatico);
        clicarCampoSelecionarValor(campoOperacao, operacaoIncluir);
        click(campoAlergenicos);
        click(alerAmendoim);
        click(alerMolusco);
        click(botaoOk);

        click(botaoProdutoInicial);
        sendKeys(campoProcurar, "CARBONATO DE MAGNESIO");
        click(produtoCarbonatoMagnesio);

        click(botaoProdutoFinal);
        sendKeys(campoProcurar, "CARBONATO DE MAGNESIO 500G");
        click(produtoCarbonatoMagnesio500);
        tempo();

        click(botaoConfirmar);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma inclusão dos alergênicos nos produtos indicados?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exbida após clicar em confirmar o formulário de cadastro automático");
        click(botaoSimAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Operação realizada com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso exibida após a conclusão do cadastro automático");

    }

    public void verificarCadAutomatico() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-17558808322310651395308 > div.grid-vertical-scroll-control\").scrollBy(0, 250)");
        click(prodTelaIniCarnobanoMagnesio);
        verificarAlergenicosCadAuto("CARBONATO DE MAGNESIO");
        click(prodTelaIniCarnobanoMagnesio500);
        verificarAlergenicosCadAuto("CARBONATO DE MAGNESIO 500G");
    }

    private void verificarAlergenicosCadManual() {
        tempo();
        long timeout = 0;
        List<WebElement> results = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                listaAlergenicosProd
                        )
                );
        Assert.assertEquals(results.size(), 3, "Verificar a quantidade alergênicos do produtos, após adicionar 3 alergênicos manualmente");

        List<String> alergenicos = new ArrayList<>();
        alergenicos.add("AMENDOIM AM");
        alergenicos.add("CRUSTÁCEO CRUS");
        alergenicos.add("MOLUSCO MOL");

        for (int index = 0; index < results.size(); index ++) {
            Assert.assertEquals(results.get(index).getText(), alergenicos.get(index), "Verificação do item " + (index + 1) + " da lista de alergênicos(nome e sigla) adicionados manualmente");
        }
    }

    private void verificarAlergenicosCadAuto(String nomeProduto) {
        tempo();
        click(nomeAlergenicoCabecalho);
        String expNome = "AMENDOIM";
        String expSigla = "AM";

        String nome = getText(nomeAlergenico1);
        String sigla = getText(siglaAlergenico1);
        Assert.assertEquals(nome, expNome, "Verificação do nome do primeiro alergênico adicionado no cadastro automático ao produto " + nomeProduto);
        Assert.assertEquals(sigla, expSigla, "Verificação da sigla do primeiro alergênico adicionado no cadastro automático ao produto " + nomeProduto);

        expNome = "MOLUSCO";
        expSigla = "MOL";
        nome = getText(nomeAlergenico2);
        sigla = getText(siglaAlergenico2);
        Assert.assertEquals(nome, expNome, "Verificação do nome do segundo alergênico adicionado no cadastro automático ao produto " + nomeProduto);
        Assert.assertEquals(sigla, expSigla, "Verificação da sigla do segundo alergênico adicionado no cadastro automático ao produto " + nomeProduto);
        click(nomeAlergenicoCabecalho);
        click(nomeAlergenicoCabecalho);
        click(botaoVoltar);
    }

    public void preencherFormCadAutomatidoExcluir() {
        tempo();
        click(botaoCadastroAutomatico);
        clicarCampoSelecionarValor(campoOperacao, operacaoExcluir);
        click(campoAlergenicos);
        click(alerAmendoim);
        click(alerMolusco);
        click(botaoOk);

        click(botaoProdutoInicial);
        sendKeys(campoProcurar, "CARBONATO DE MAGNESIO");
        click(produtoCarbonatoMagnesio);

        click(botaoProdutoFinal);
        sendKeys(campoProcurar, "CARBONATO DE MAGNESIO 500G");
        click(produtoCarbonatoMagnesio500);
        tempo();

        click(botaoConfirmar);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão dos alergênicos nos produtos indicados?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exbida após clicar em confirmar o formulário de cadastro automático");
        click(botaoSimAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Operação realizada com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso exibida após a conclusão do cadastro automático");

    }

    public void verificarExclusaoAutomatica() {
        tempo();
        click(prodTelaIniCarnobanoMagnesio);
        mensagemExclusaoAutomatica("CARBONATO DE MAGNESIO");
        click(prodTelaIniCarnobanoMagnesio500);
        mensagemExclusaoAutomatica("CARBONATO DE MAGNESIO 500G");
    }

    private void mensagemExclusaoAutomatica(String nomeProduto) {
        String mensagem = getText(mensagemNaoHaRegistroTelaAler);
        String mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de não há registros, após a exclusão automática no produto " + nomeProduto);
        click(botaoVoltar);
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoDeOpcoesDaTela) && !returnClassOpened(botaoPesquisar)) {
            click(botaoPesquisar);
        } else if (!returnClassOpened(botaoDeOpcoesDaTela)){
            click(botaoDeOpcoesDaTela);
            click(botaoPesquisar);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

    public void camposObrigatorioCadAuto() {
        tempo();
        click(botaoCadastroAutomatico);
        tempo();
        click(botaoConfirmar);
        String alergenicos = getText(campoObrigatorioAlergicosCadAuto);
        String produtoInicial = getText(campoObrigatorioProdInicialCadAuto);
        String produtoFinal = getText(campoObrigatorioProdFinalCadAuto);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(alergenicos, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo alergênicos no formulário de cadastro automático");
        Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo produto inicial no formulário de cadastro automático");
        Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo produto final no formulário de cadastro automático");
    }

}
