package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.apache.maven.shared.utils.cli.CommandLineCallable;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class CalendarioDeCardapioPage extends PageBase {

    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Calendário de Cardápio']");
    By telaCalendarioDeCardapio = By.xpath("//div[text() = 'Calendário de Cardápio']");
    By mesCardapioFechado = By.xpath("//span[text() = 'Março']");
    By mesCardapio = By.xpath("//span[text() = 'Janeiro']");
    By limpaCampoAno = By.xpath("//div[@id = 'DTANOCALENCARD']//span[@zh-icon='no-border close-x']");
    By clicaCampoAno = By.xpath("//div[@id = 'DTANOCALENCARD']");
    By anoCalendarioCardapio = By.xpath("//div[@data-val='2025']");
    By btnSelecionarAno = By.xpath("//div[text() = 'Selecionar']");
    By btnAplicarFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnExportarCalendario = By.xpath("//span[text() = 'Exportar Calendário de Cardápio']");
    By btnLogCalendarioCardapio = By.xpath("//span[text() = 'Log Calendário de Cardápio']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");
    By novoFiltro = By.xpath("//span[@data-zh-icon='filter no-border icon-white']");
    By limpaFiltroUnidade = By.xpath("//div[@id ='CDFILIAL_FILTER']//span[@zh-icon='no-border close-x']");
    By buscaUnidade = By.xpath("//div[@id ='CDFILIAL_FILTER']//span[@zh-icon='no-border search']");
    By btnEditar = By.xpath("//li[@data-zh-id='66364606739248223931427']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By clicaPrevisaoLiberacao = By.xpath("//div[@class = 'zh-select-date zh-field-DTPREVLIBECARD']");
    By previsaoLiberacao = By.xpath("//input[@id = 'DTPREVLIBECARD']");
    By diasAprovacaoUnidade = By.xpath("//input[@id = 'QTDIAPROFIL']");
    By limiteAprovacaoAprovacaoUnidade = By.xpath("//input[@id = 'DTLIMAPROVFILI']");
    By diasAprovacaoMatriz = By.xpath("//input[@id = 'QTDIAPROMAT']");
    By limiteAprovacaoMatriz = By.xpath("//input[@id = 'DTLIMAPROVMATR']");
    By limpaDataLiberacao = By.xpath("//div[@class = 'zh-select-date zh-field-DTPREVLIBECARD']//span[@zh-icon='no-border close-x']");
    By limpaDataAprovFilial = By.xpath("//div[@data-zh-id='66364606726777470201419']//span[@zh-icon='no-border close-x']");
    By limpaDataAprovMatriz = By.xpath("//div[@data-zh-id='6636460676708352121423']//span[@zh-icon='no-border close-x']");
    By diasProrrogacao = By.xpath("//input[@id = 'QTDIAPRORAPROV']");
    By custoBaseCardapio = By.xpath("//input[@id = 'DTBASCONCUSPLAN']");

    By validaDataPrevisaoLiberacao = By.xpath("//*[@id='span-field-DTPREVLIBECARD']/p");
    By validaDataAprovacaoUnidade = By.xpath("//*[@id='span-field-DTLIMAPROVFILI']/p");
    By validaDataAprovacaoMatriz = By.xpath("//*[@id='span-field-DTLIMAPROVMATR']/p");
    By validaDataCustoCardapio = By.xpath("//*[@id='span-field-DTBASCONCUSPLAN']/p");

    By campoPrevisaoLiberacao = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[2]/div[1]/div/div[2]/span");
    By campoLimiteAprovUnidade = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[3]/div[1]/div/div[2]/span");
    By campoLimiteAprovMatriz = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section/div/div[4]/div[1]/div/div[2]/span");

    //Prorrogação Automática
    By btnProrrogacaoAutomatica = By.xpath("//span[text() = 'Prorrogação Automática']");
    By lupaAgrupamentoUnidade = By.xpath("//div[@id= 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By informaBusca = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//section[@data-zh-id='9000']//*[@class = 'tr cell1']");
    By checkBoxTodasUnidades = By.xpath("//*[@zh-icon='checked no-border']");
    By campoUnidade = By.xpath("//div[@name = 'CDFILIAL']");
    By selecionaUnidade = By.xpath("//div[@class= 'th grid-checkbox-column fixed']");
    By btnOk = By.xpath("//span[text() = 'Ok']");
    By mesAprovacao = By.xpath("//div[@id = 'MESAPRORAPROV']");
    By clicaAbril = By.xpath("//div[@class = 'dw-i']//span[text() = 'Abril']");
    By clicaFevereiro = By.xpath("//div[@class = 'dw-i']//span[text() = 'Fevereiro']");
    By selecionaMesCardapio = By.xpath("//div[@class = 'dw-i']//span[text() = 'Janeiro']");
    By selecionaAnoCardapio = By.xpath("//div[text() = '2025']");
    By btnSelecionar = By.xpath("//div[text() = 'Selecionar']");
    By qtdDiasProrrogacao = By.xpath("//input[@name = 'QTDIAPRORAPROV']");
    By btnProrrogar = By.xpath("//li[@data-zh-id='6636460673117284607292']");
    By confirmaAlerta = By.xpath("//button[@class = 'zh-alert-button']");

    By retornaDiasProrrogacaoUnidade = By.xpath("//*[@id='span-field-QTDIAPROFIL']/p");
    By retornaDiasProrrogacaoMatriz = By.xpath("//*[@id='span-field-QTDIAPROMAT']/p");
    By retornaDiasProrrogacao = By.xpath("//*[@id='span-field-QTDIAPRORAPROV']/p");
    By msgEsperadaDiasProrrogacao = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[7]");

    //Exportar Calendário de Cardápio

    By anoOrigem = By.xpath("//div[@id = 'ANO_ORIGEM']");
    By limpaAnoOrigem = By.xpath("//div[@name = 'ANO_ORIGEM']//span[@zh-icon='no-border close-x']");
    By campoCalendario = By.xpath("//div[@id = 'CALENDARIO']");
    By marcaMesExportacao = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By anoDestino = By.xpath("//div[@id = 'ANO_DESTINO']");
    By agrupamentoUnidade = By.xpath("//div[@name= 'NMGRUPFILI']//span[@zh-icon = 'no-border search']");
    By checkBoxTodasFiliais = By.xpath("//label[@for= 'zh-checkbox-T_CDFILIAL']//span[@zh-icon = 'checked no-border']");
    By campoUnidadeDestino = By.xpath("//div[@id = 'CDFILIAL_DESTINO']");
    By btnExportar = By.xpath("//li[@data-zh-id='6636460672334663362267']//span[text() = 'Exportar']");
    By previsaoLiberacaoCard = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[2]/span");
    By diasAprovUnidade = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[3]/span");
    By limiteAprovacaoUnidade = By.xpath("//input[@id = 'DTLIMAPROVFILI']");
    By limiteAprovUnidade = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[4]/span");
    By diasAprovMatriz = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[5]/span");
    By limiteAprovMatriz = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[6]/span");
    By diasProrrogacaoAprov = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[7]/span");
    By custoBaseCardapioAprov = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[8]/span");

    //Log de calendário
    By btnConfirmar = By.xpath("//div[@class = 'zh-footer-right']//li[@data-zh-id='6636460673716964049275']//span[text() = 'Confirmar']");

    public void acessaTelaCalendarioCardapio(){
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Calendário de Cardápio");
        tempo();
        click(selecionaTela);
        tempo();
    }

    public String validaAcessoTela(){
        return getText(telaCalendarioDeCardapio);
    }

    public void realizarFiltro(String CARDBLOQUEADO){
        if (CARDBLOQUEADO == "S"){
            tempo();
            click(btnAplicarFiltro);
            tempo();
        }else {
            tempo();
            click(limpaCampoAno);
            tempo();
            click(clicaCampoAno);
            tempo();
            click(anoCalendarioCardapio);
            tempo();
            click(btnSelecionarAno);
            tempo();
            click(btnAplicarFiltro);
            tempo();
        }

    }

    public void clicaMesCardapioFechado(){
        realizarFiltro("S");

        tempo();
        click(mesCardapioFechado);
        tempo();
        if (!returnIfElementExists(btnEditar)) {
            tempo();
            click(btnVoltar);
            tempo();
        }
    }

    public void validaCamposObrigatorios(){
        click(limpaCampoAno);
        tempo();
        click(clicaCampoAno);
        tempo();
        click(anoCalendarioCardapio);
        tempo();
        click(btnSelecionarAno);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(mesCardapio);
        tempo();
        click(btnEditar);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String retornaMsgPrevisaoLiberacao(){
        return getText(campoPrevisaoLiberacao);
    }

    public String retornaMsgLimiteAprovUnidade(){
        return getText(campoLimiteAprovUnidade);
    }

    public String retornaMsgLimiteAprovMatriz(){
        return getText(campoLimiteAprovMatriz);
    }

    public void alteraDataCalendario(String NRDIASPRORROGUNIDADE,String NRDIASPRORROGMatriz,String NRDIASPRORROG){
        realizarFiltro("N");
        click(mesCardapio);
        tempo();
        tempo();
        click(btnEditar);
        tempo();
        click(diasAprovacaoUnidade);
        clearAndSendKeys(diasAprovacaoUnidade,NRDIASPRORROGUNIDADE);
        tempo();
        click(diasAprovacaoMatriz);
        clearAndSendKeys(diasAprovacaoMatriz,NRDIASPRORROGMatriz);
        tempo();
        click(diasProrrogacao);
        clearAndSendKeys(diasProrrogacao,NRDIASPRORROG);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String diasProrrogacaoUnidade(){return getText(retornaDiasProrrogacaoUnidade);}

    public String diasProrrogacaoMatriz(){return getText(retornaDiasProrrogacaoMatriz);}

    public String diasProrrogacao(){return getText(retornaDiasProrrogacao);}

    public void insereDataAnteriorAprovacaoCard(String TIPOPROCESSAMENTO){
        realizarFiltro("N");
        click(mesCardapio);
        tempo();
        click(btnEditar);
        tempo();
        if (TIPOPROCESSAMENTO == "Filial") {
            click(limpaDataAprovFilial);
            click(limiteAprovacaoAprovacaoUnidade);
            tempo();
            clearAndSendKeys(limiteAprovacaoAprovacaoUnidade, "01/11/2023");
        } else{
            click(limpaDataAprovMatriz);
            tempo();
            click(limiteAprovacaoMatriz);
            tempo();
            clearAndSendKeys(limiteAprovacaoMatriz, "01/11/2023");

        }
        tempo();
        click(btnSalvar);
        tempo();
        click(confirmaAlerta);
        tempo();
        if (TIPOPROCESSAMENTO == "Filial") {
            click(diasAprovacaoUnidade);
            clearAndSendKeys(diasAprovacaoUnidade, "2");
        }else{
            click(diasAprovacaoMatriz);
            clearAndSendKeys(diasAprovacaoMatriz, "3");
        }
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void insereCalendarioCardapio(String DTLIBERACAO, String DTCUSTO){
        realizarFiltro("N");
        click(mesCardapio);
        tempo();
        click(btnEditar);
        tempo();
        click(limpaDataLiberacao);
        tempo();
        clickPerformData(previsaoLiberacao);
        clearAndSendKeys(previsaoLiberacao,DTLIBERACAO);
        tempo();
        clickPerformData(custoBaseCardapio);
        tempo();
        clearAndSendKeys(custoBaseCardapio,DTCUSTO);
        tempo();
        click(btnSalvar);
        tempo();

    }

    public String validaDataLiberacao(){
        return getText(validaDataPrevisaoLiberacao);
    }

    public String validaDataCusto() {
        return getText(validaDataCustoCardapio);
    }

    public void prorrogacaoAutomatica(String TPPRORROG,String NRDIASPRORROG){
        realizarFiltro("N");
        tempo();
        click(btnAcoes);
        tempo();
        click(btnProrrogacaoAutomatica);
        tempo();
        if (TPPRORROG == "A"){
            click(lupaAgrupamentoUnidade);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca,"0000000002");
            tempo();
            click(selecionaBusca);

        }else if(TPPRORROG == "U"){
            click(checkBoxTodasUnidades);
            click(campoUnidade);
            tempo();
            click(selecionaUnidade);
            click(btnOk);
        }
        tempo();
        clickPerform(mesAprovacao);
        tempo();
        click(clicaAbril);
        click(clicaFevereiro);
        tempo();
        click(selecionaMesCardapio);
        tempo();
        click(selecionaAnoCardapio);
        tempo();
        click(btnSelecionar);
        tempo();
        clickPerform(qtdDiasProrrogacao);
        clearAndSendKeys(qtdDiasProrrogacao,NRDIASPRORROG);
        tempo();
        click(btnProrrogar);
        tempo();
        click(confirmaAlerta);
        tempo();
    }

    public String msgEncontradaDiasProrrogacao(){
        return getText(msgEsperadaDiasProrrogacao);
    }

    public void exportarCalendarioCardapio(String TPEXPORTACAO,String CDUNIDADE){
        realizarFiltro("N");
        tempo();
        click(btnAcoes);
        tempo();
        click(btnExportarCalendario);
        tempo();
        tempo();
        click(anoOrigem);
        tempo();
        click(selecionaAnoCardapio);
        tempo();
        click(btnSelecionar);
        tempo();
        click(campoCalendario);
        tempo();
        click(marcaMesExportacao);
        click(btnOk);
        tempo();
        click(anoDestino);
        tempo();
        click(selecionaAnoCardapio);
        click(btnSelecionar);
        tempo();
        if (TPEXPORTACAO == "A"){
            click(lupaAgrupamentoUnidade);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, "0000000001");
            tempo();
            click(selecionaBusca);
        }else {
            click(checkBoxTodasFiliais);
            click(campoUnidadeDestino);
            tempo();
            click(informaBusca);
            clearAndSendKeys(informaBusca, CDUNIDADE);
            tempo();
            click(selecionaUnidade);
            tempo();
            click(btnOk);
        }
        tempo();
        click(btnExportar);
        tempo();
        click(confirmaAlerta);
        tempo();
        click(novoFiltro);
        tempo();
        click(limpaFiltroUnidade);
        click(buscaUnidade);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,CDUNIDADE);
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }

    public String validaPrevisaoLiberacao() {
        return getText(previsaoLiberacaoCard);
    }

    public String validaDiasAprovacaoUnidade() {
        return getText(diasAprovUnidade);
    }

    public String validaLimiteAprovacaoUnidade() {
        return getText(limiteAprovUnidade);
    }

    public String validaDiasAprovacaoMatriz() {
        return getText(diasAprovMatriz);
    }

    public String validaLimiteAprovacaoMatriz() {
        return getText(limiteAprovMatriz);
    }

    public String validaDiasProrrogacaoAprovacao() {
        return getText(diasProrrogacaoAprov);
    }

    public String validaCustoBaseCardapio() {
        return getText(custoBaseCardapioAprov);

    }

    public void logCalendarioCardapio(){
        realizarFiltro("N");
        tempo();
        click(btnAcoes);
        tempo();
        click(btnLogCalendarioCardapio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
    }


}
