package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmissaoCardapioDiaPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoEmissaoCarpioDia = By.xpath("//span[text() = 'Emissão do Cardápio do Dia']");

    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioCardapioDiaAlergenico = By.xpath("//div[@class='list-items show-select']//span[text() = 'Cardápio do Dia - Alergênicos']");
    By relatorioCardapioDiaData = By.xpath("//div[@class='list-items show-select']//span[text() = 'Cardápio do Dia (por Data)']");
    By relatorioCardapioDiaServico = By.xpath("//div[@class='list-items show-select']//span[text() = 'Cardápio do Dia (por Serviço)']");
    By relatorioEmissaoCardapio = By.xpath("//div[@class='list-items show-select']//span[text() = 'Emissão do Cardápio']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-id=\"102347613741998251141232\"]//span[text() = '9999 | DEPOSITO BC 129']");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");
    By botaoTodosServicos = By.xpath("//div[@data-zh-id=\"102347613716531060481245\"]//span[@class=\"zh-icon zh-icon-checked zh-icon-no-border\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoCampoRelatorio = By.xpath("//div[@data-zh-id=\"102347613723060422821229\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoUnidade = By.xpath("//div[@data-zh-id=\"102347613741998251141232\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoIntervaloData = By.xpath("//div[@data-zh-id=\"1023476137277411187401\"]//span[@zh-icon=\"no-border close-x\"]");
    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"102347613723060422821229\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"102347613741998251141232\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioIntervaloData = By.xpath("//div[@data-zh-id=\"1023476137277411187401\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"102347613712671009461241\"]//div[@class=\"zh-validation\"]/span");

    By campoQuebraPagina = By.xpath("//label[@for=\"zh-checkbox-DSQUEBRAPAGINA\" and @class=\"zh-box-label\"]");
    By campoImprimirMensagem = By.xpath("//label[@for=\"zh-checkbox-DSIMPRIMEMENS\" and @class=\"zh-box-label\"]");
    By campoImprimirNomeFantasia = By.xpath("//label[@for=\"zh-checkbox-IMPNMFANTASIA\" and @class=\"zh-box-label\"]");
    By campoImprimirNDPCAl = By.xpath("//label[@for=\"zh-checkbox-DSIMPNDPCAL\" and @class=\"zh-box-label\"]");
    By campoImprimirNutrientes = By.xpath("//label[@for=\"zh-checkbox-DSNUTRI\" and @class=\"zh-box-label\"]");
    By campoConsiderarPratosOpcoes = By.xpath("//label[@for=\"zh-checkbox-PRATOOPCAONUTR\" and @class=\"zh-box-label\"]");

    By checkBoxQuebraPagia = By.id("zh-checkbox-DSQUEBRAPAGINA");
    By checkBoxImprimirMensagem = By.id("zh-checkbox-DSIMPRIMEMENS");
    By checkBoxImprimirNDPCAL = By.id("zh-checkbox-DSIMPNDPCAL");
    By checkBoxImprimirNomeFantasia = By.id("zh-checkbox-IMPNMFANTASIA");
    By checkBoxImprimirNutrientes = By.id("zh-checkbox-DSNUTRI");
    By checkBoxConsiderarPratosOpcoes = By.id("zh-checkbox-PRATOOPCAONUTR");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']/div");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");


    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Emissão do Cardápio do Dia");
        click(selecionarOpcaoEmissaoCarpioDia);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        tempo();
        switch (nomeDoRelatorio) {
            case "Cardápio do Dia - Alergênicos":
                clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioDiaAlergenico);
                break;
            case "Cardápio do Dia (por Data)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioDiaData);
                break;
            case "Cardápio do Dia (por Serviço)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioDiaServico);
                break;
            case "Emissão do Cardápio":
                clicarCampoSelecionarValor(campoRelatorio, relatorioEmissaoCardapio);
                break;
        }
    }

    public void selecionarUnidadeDepositoBc129() {
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc129);
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarServicos() {
        click(botaoTodosServicos);
        click(campoServico);
        click(servicoRetiradas);
        click(servicoSolicitacao);
        click(botaoOk);
    }

    public void geraRelatorio() {
        geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    public void camposObrigatorios() {
        tempo();
        tempo();
        click(botaoCampoRelatorio);
        click(botaoCampoUnidade);
        click(botaoCampoIntervaloData);
        click(botaoTodosServicos);
        click(botaoRelatorio);

        //mensagem encontradas nos campos obrigatórios
        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String data = getText(mensagemObrigatorioIntervaloData);
        String servico = getText(mensagemObrigatorioServico);

        String mensagemEsperada = "Campo obrigatório";
        String mensagemEsperadaIntervaloData = "Intervalo de data é obrigatório!";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo relatório");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo unidade");
        Assert.assertEquals(data, mensagemEsperadaIntervaloData, "Verificação da mensagem de campo obrigatório, no campo intervalo data");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo serviço");
    }

    public void desabilitarCheckBoxQuebraPagia() {
        click(campoImprimirMensagem);
        tempo();
        boolean permiteSelecionar = returnIfElementIsEnabled(checkBoxQuebraPagia);
        Assert.assertEquals(permiteSelecionar, false, "Verificar se após selecionar o imprimir mensagem, o campo quebra de página ainda é possível selecioná-lo");
    }

    public void habilitarConsiderarPratosOpcoes() {
        tempo();
        boolean existsConsiderarPratoOpcao = returnIfElementExists(campoConsiderarPratosOpcoes);
        Assert.assertEquals(existsConsiderarPratoOpcao, false, "Verificar se antes de clicar no campo imprimir nutrientes, o campo considerar pratos opção está visivel");
        click(campoImprimirNutrientes);
        tempo();
        existsConsiderarPratoOpcao = returnIfElementExists(campoConsiderarPratosOpcoes);
        Assert.assertEquals(existsConsiderarPratoOpcao, true, "Verificar se após de clicar no campo imprimir nutrientes, o campo considerar pratos opção está visivel");
    }

    public void verificarCheckBoxSelecionados() {
        tempo();
        boolean quebraPagina = returnIfElementIsSelected(checkBoxQuebraPagia);
        Assert.assertEquals(quebraPagina, true, "Verificar se a quebra de página está selecionada");
        tempo();
        click(campoQuebraPagina);
        quebraPagina = returnIfElementIsSelected(checkBoxQuebraPagia);
        Assert.assertEquals(quebraPagina, false, "Verificar se após clicar na opção 'Considerar Pratos Opção', a mesma fica desmarcada");

        click(campoImprimirMensagem);
        click(campoImprimirNomeFantasia);
        click(campoImprimirNDPCAl);
        click(campoImprimirNutrientes);

        boolean imprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        boolean imprimirNomeFantasia = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        boolean imprimirNDPCAL = returnIfElementIsSelected(checkBoxImprimirNDPCAL);
        boolean imprimirNutrientes = returnIfElementIsSelected(checkBoxImprimirNutrientes);
        boolean considerarPratosOpcoes = returnIfElementIsSelected(checkBoxConsiderarPratosOpcoes);
        Assert.assertEquals(imprimirMensagem, true, "Verificar se o campo imprimir mensagem está selecionado após clicar no mesmo");
        Assert.assertEquals(imprimirNomeFantasia, true, "Verificar se o campo nome fantasia está selecionado após clicar no mesmo");
        Assert.assertEquals(imprimirNDPCAL, true, "Verificar se o campo imprimir NDPCAL está selecionado após clicar no mesmo");
        Assert.assertEquals(imprimirNutrientes, true, "Verificar se o campo imprimir nutrientes está selecionado após clicar no mesmo");
        Assert.assertEquals(considerarPratosOpcoes, true, "Verificar se o campo considerar pratos opções está selecionado após clicar no mesmo");

        click(campoConsiderarPratosOpcoes);
        considerarPratosOpcoes = returnIfElementIsSelected(checkBoxConsiderarPratosOpcoes);
        Assert.assertEquals(considerarPratosOpcoes, false, "Verificar se após clicar na opção 'Considerar Pratos Opção', a mesma fica desmarcada");
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void verificarCamposHabilitadosPeloRelatorios() {
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioDiaAlergenico);
        boolean imprimirMensagem = returnIfElementIsEnabled(checkBoxImprimirMensagem);
        boolean imprimirNomeFantasia = returnIfElementIsEnabled(checkBoxImprimirNomeFantasia);
        boolean quabraPagina = returnIfElementIsEnabled(checkBoxQuebraPagia);
        boolean imprimirNutrientes = returnIfElementIsEnabled(checkBoxImprimirNutrientes);
        Assert.assertEquals(imprimirMensagem, false, "Verificar se com o relatório 'Cardápio do Dia - Alergênicos' selecionado o check-box 'imprimir mensagem' está habilitado");
        Assert.assertEquals(imprimirNomeFantasia, true, "Verificar se com o relatório 'Cardápio do Dia - Alergênicos' selecionado o check-box 'imprimir nome fantasia' está habilitado");
        Assert.assertEquals(quabraPagina, true, "Verificar se com o relatório 'Cardápio do Dia - Alergênicos' selecionado o check-box 'quebra de página' está habilitado");
        Assert.assertEquals(imprimirNutrientes, false, "Verificar se com o relatório 'Cardápio do Dia - Alergênicos' selecionado o check-box 'imprimir nutrientes' está habilitado");

        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioDiaData);
        imprimirMensagem = returnIfElementIsEnabled(checkBoxImprimirMensagem);
        imprimirNomeFantasia = returnIfElementIsEnabled(checkBoxImprimirNomeFantasia);
        quabraPagina = returnIfElementIsEnabled(checkBoxQuebraPagia);
        imprimirNutrientes = returnIfElementIsEnabled(checkBoxImprimirNutrientes);
        Assert.assertEquals(imprimirMensagem, true, "Verificar se com o relatório 'Cardápio do Dia (por Data)' selecionado o check-box 'imprimir mensagem' está habilitado");
        Assert.assertEquals(imprimirNomeFantasia, true, "Verificar se com o relatório 'Cardápio do Dia (por Data)' selecionado o check-box 'imprimir nome fantasia' está habilitado");
        Assert.assertEquals(quabraPagina, true, "Verificar se com o relatório 'Cardápio do Dia (por Data)' selecionado o check-box 'quebra de página' está habilitado");
        Assert.assertEquals(imprimirNutrientes, true, "Verificar se com o relatório 'Cardápio do Dia (por Data)' selecionado o check-box 'imprimir nutrientes' está habilitado");

        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioDiaServico);
        imprimirMensagem = returnIfElementIsEnabled(checkBoxImprimirMensagem);
        imprimirNomeFantasia = returnIfElementIsEnabled(checkBoxImprimirNomeFantasia);
        quabraPagina = returnIfElementIsEnabled(checkBoxQuebraPagia);
        imprimirNutrientes = returnIfElementIsEnabled(checkBoxImprimirNutrientes);
        Assert.assertEquals(imprimirMensagem, true, "Verificar se com o relatório 'Cardápio do Dia (por Serviço)' selecionado o check-box 'imprimir mensagem' está habilitado");
        Assert.assertEquals(imprimirNomeFantasia, true, "Verificar se com o relatório 'Cardápio do Dia (por Serviço)' selecionado o check-box 'imprimir nome fantasia' está habilitado");
        Assert.assertEquals(quabraPagina, true, "Verificar se com o relatório 'Cardápio do Dia (por Serviço)' selecionado o check-box 'quebra de página' está habilitado");
        Assert.assertEquals(imprimirNutrientes, true, "Verificar se com o relatório 'Cardápio do Dia (por Serviço)' selecionado o check-box 'imprimir nutrientes' está habilitado");

        clicarCampoSelecionarValor(campoRelatorio, relatorioEmissaoCardapio);
        imprimirMensagem = returnIfElementIsEnabled(checkBoxImprimirMensagem);
        imprimirNomeFantasia = returnIfElementIsEnabled(checkBoxImprimirNomeFantasia);
        quabraPagina = returnIfElementIsEnabled(checkBoxQuebraPagia);
        imprimirNutrientes = returnIfElementIsEnabled(checkBoxImprimirNutrientes);
        Assert.assertEquals(imprimirMensagem, false, "Verificar se com o relatório 'Emissão do Cardápio' selecionado o check-box 'imprimir mensagem' está habilitado");
        Assert.assertEquals(imprimirNomeFantasia, true, "Verificar se com o relatório 'Emissão do Cardápio' selecionado o check-box 'imprimir nome fantasia' está habilitado");
        Assert.assertEquals(quabraPagina, false, "Verificar se com o relatório 'Emissão do Cardápio' selecionado o check-box 'quebra de página' está habilitado");
        Assert.assertEquals(imprimirNutrientes, false, "Verificar se com o relatório 'Emissão do Cardápio' selecionado o check-box 'imprimir nutrientes' está habilitado");
    }

}
