package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class IncidenciaCardapioPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoIncidenciaCardapio = By.xpath("//span[text() = 'Incidência de Cardápio']");

    By campoRelatorio = By.id("REPORTNAME");
    By relatorioIncidenciaCardapio = By.xpath("//div[@data-zh-id=\"14691402852440009809253\"]//div[@class=\"list-items show-select\"]//span[text() = 'Incidência de Cardápio']");

    By checkBoxTodasUnidades = By.xpath("//label[@for=\"zh-checkbox-TFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");

    By checkBoxTodosGrupoServicos = By.xpath("//label[@for=\"zh-checkbox-TGRUPSERV\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoGrupoServico = By.id("NMGRUPSERV");
    By grupoServicoPreparados = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'PREPAROS']");
    By grupoServicoCompras = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'COMPRAS']");
    By grupoServicoPedidos = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'PEDIDOS']");

    By checkBoxTodoServicos = By.xpath("//label[@for=\"zh-checkbox-TSERVICO\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoPalestra = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'PALESTRA']");
    By servicoLanche = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'LANCHE']");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");

    By inputCheckBoxTodasUnidades = By.id("zh-checkbox-TFILIAL");
    By inputCheckBoxTodosGrupoServicos = By.id("zh-checkbox-TGRUPSERV");
    By inputCheckBoxTodoServicos = By.id("zh-checkbox-TSERVICO");

    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button");
    By botaSetaDiminuirAnoCalendario = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//div[@zh-icon=\"previous no-border\"]");
    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORTNAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoPratoInicial = By.xpath("//div[@id=\"NMPRATOINI\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoPratoFinal = By.xpath("//div[@id=\"NMPRATOFIN\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoMesInicial = By.xpath("//div[@id=\"MESINICIO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoMesFinal = By.xpath("//div[@id=\"MESFINAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProcurar = By.xpath("//li[@class=\"float-action expandable\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");

    By campoMesInicial = By.id("MESINICIO");
    By campoMesFinal = By.id("MESFINAL");
    By anoCalendario = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//h3[@class=\"calendar-heading\"]");
    By mesAbril = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//div[text() = 'Abr']");
    By mesMaio = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//div[text() = 'Mai']");

    By pratoFeijoadaSimples = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJOADA SIMPLES']");
    By pratoCafeCremoso = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'CAFÉ CREMOSO']");

    By opcoesNivel = By.xpath("//div[@data-zh-id=\"14691402853085011389293\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By nivelSelecionado = By.xpath("//div[@data-zh-id=\"14691402853085011389293\"]//span[@class=\"current\"]");
    By campoNivel = By.xpath("//div[@data-zh-id=\"14691402853085011389293\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By nivel1 = By.xpath("//div[@data-zh-id=\"14691402853085011389293\"]//li[text() = 'Nível 1']");

    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoArroz = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'ARROZ']");
    By tipoPratoSalada = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'SALADA']");
    By tipoPratoPrincipal = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'PRATO PRINCIPAL']");
    By tipoPratoSobremesa = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'SOBREMESA']");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for=\"radio-QR2TYPE-PDF\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"14691402852440009809253\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"1469140285163580243258\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioGrupoServico = By.xpath("//div[@data-zh-id=\"14691402852844357358267\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"1469140285571225882275\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesInicial = By.xpath("//div[@data-zh-id=\"14691402852260985369284\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesFinal = By.xpath("//div[@data-zh-id=\"14691402852796646442285\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNivel = By.xpath("//div[@data-zh-id=\"14691402853085011389293\"]//div[@class=\"zh-validation\"]/span");

    public void selecionarMesesIniFim() {
        click(campoMesInicial);
        int ano = Integer.parseInt(getText(anoCalendario));
        if (Integer.parseInt(getText(anoCalendario)) > 2024) {
            int diferencaAno = ano - 2024;
            for (int x = 1; x <= diferencaAno; x++) click(botaSetaDiminuirAnoCalendario);
        }
        click(mesAbril);

        click(campoMesFinal);
        ano = Integer.parseInt(getText(anoCalendario));
        if (Integer.parseInt(getText(anoCalendario)) > 2024) {
            int diferencaAno = ano - 2024;
            for (int x = 1; x <= diferencaAno; x++) click(botaSetaDiminuirAnoCalendario);
        }
        click(mesMaio);
    }

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Incidência de Cardápio");
        click(selecionarOpcaoIncidenciaCardapio);
    }

    public void selecionarRelatorioIncidenciaCardapio() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioIncidenciaCardapio);
    }

    public void checkBoxTodosSelecionados() {
        Assert.assertTrue(returnIfElementIsSelected(inputCheckBoxTodasUnidades), "Verificar se o check-box 'Todas' do campo unidade está selecionado");
        Assert.assertTrue(returnIfElementIsSelected(inputCheckBoxTodosGrupoServicos), "Verificar se o check-box 'Todos' do campo grupo de serviço está selecionado");
        Assert.assertTrue(returnIfElementIsSelected(inputCheckBoxTodoServicos), "Verificar se o check-box 'Todos' do campo serviço está selecionado");
    }

    public void selecionarUnidades() {
        click(checkBoxTodasUnidades);
        click(campoUnidade);
        click(unidadeDepositoJabaquara);
        click(unidadeDepositoBc129);
        click(botaoOk);
    }

    public void selecionarGrupoServico() {
        click(checkBoxTodosGrupoServicos);
        click(campoGrupoServico);
        click(grupoServicoPreparados);
        click(grupoServicoCompras);
        click(grupoServicoPedidos);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(checkBoxTodoServicos);
        click(campoServico);
        click(servicoPalestra);
        click(servicoLanche);
        click(servicoSolicitacao);
        click(botaoOk);
    }

    public void selecionarPratoIniFim() {
        click(botaoCampoPratoInicial);
        click(botaoCampoPratoInicial);
        sendKeys(campoProcurar, "FEIJOADA SIMPLES");
        click(pratoFeijoadaSimples);
        tempo();
        click(botaoCampoPratoFinal);
        sendKeys(campoProcurar, "CAFÉ CREMOSO");
        click(pratoCafeCremoso);
    }

    public void selecionarNivel() {
        clicarCampoSelecionarValor(campoNivel, nivel1);
    }

    public void selecionarTipoPrato() {
        click(campoTipoPrato);
        click(tipoPratoArroz);
        click(tipoPratoSalada);
        click(tipoPratoPrincipal);
        click(tipoPratoSobremesa);
        click(botaoOk);
    }

    public void camposObrigatorios() {
        click(botaoCampoRelatorio);
        click(checkBoxTodasUnidades);
        click(checkBoxTodosGrupoServicos);
        click(checkBoxTodoServicos);
        click(botaoCampoMesInicial);
        click(botaoCampoMesFinal);
        click(botaoRelatorio);

        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String grupoServico = getText(mensagemObrigatorioGrupoServico);
        String servico = getText(mensagemObrigatorioServico);
        String mesInicial = getText(mensagemObrigatorioMesInicial);
        String mesFinal = getText(mensagemObrigatorioMesFinal);
        String nivel = getText(mensagemObrigatorioNivel);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Relatório'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Unidade'");
        Assert.assertEquals(grupoServico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Grupo de Serviço'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Serviço'");
        Assert.assertEquals(mesInicial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Mês Inicial'");
        Assert.assertEquals(mesFinal, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Mês Final'");
        Assert.assertEquals(nivel, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Nível'");
    }

    public void verificarNiveis() {
        tempo();
        click(campoNivel);
        tempo();

        long timeout = 0;
        List<WebElement> results = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                opcoesNivel
                        )
                );

        Assert.assertEquals(results.size(), 4, "Verificar a quantidade de níveis para totalização");

        int valorNivel = 1;
        for (WebElement nivel : results) {
            String niv = "Nível " + valorNivel;
            Assert.assertEquals(nivel.getText(), niv);
            valorNivel++;
        }

        results.get(3).click();
        Assert.assertEquals(getText(nivelSelecionado), "Nível 4", "Verificar valor do nível de totalização selecionado");
    }

    public void pratoInicialDeveSerMenorQueFinal() {
        tempo();
        click(botaoCampoPratoInicial);
        tempo();
        click(botaoCampoProcurar);
        sendKeys(campoProcurar, "CAFÉ CREMOSO");
        click(pratoCafeCremoso);
        tempo();
        click(botaoCampoPratoFinal);
        sendKeys(campoProcurar, "FEIJOADA SIMPLES");
        click(pratoFeijoadaSimples);

        selecionarNivel();
        click(botaoRelatorio);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Prato inicial deve ser menor em relação ao prato final";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela ao tentar gerar o relatório selecionar um prato inicial maior que o final");
        click(botaoOkAlerta);
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}
