package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.codehaus.plexus.util.StringUtils;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class RequisicaoExtraPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRequisicaoExtra = By.xpath("//span[text() = 'Requisição Extra']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id='192767907621794425041053']//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By unidadeDepositoBc111 = By.xpath("//div[@data-zh-id='192767907621794425041053']//span[text() = '0003 | DEPOSITO BC 111']");
    By campoServico = By.id("NMSERVICO");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-id=\"192767907624930802671055\"]//span[text() = '00002 | ALMOÇO ESPECIAL | 05:00']"); //servico unidade jabaquara
    By servicoAlmoco = By.xpath("//div[@data-zh-id=\"192767907624930802671055\"]//span[text() = '00003 | ALMOÇO | 09:30']");
    By campoProcurarNrRequisicaoFiltroInicial = By.xpath("//section[@class=\"popup-content\"]//input[@placeholder=\"Procurar\"]");
    By campoProdutosFiltroInicial = By.xpath("//div[@data-zh-id=\"192767907615411496385352\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By produtosMateriaPrima = By.xpath("//div[@data-zh-id=\"192767907615411496385352\"]//li[text() = 'Matéria Prima']");
    By produtosConsumoFixo = By.xpath("//div[@data-zh-id=\"192767907615411496385352\"]//li[text() = 'Consumo Fixo']");
    By produtosConsumoPerCapta = By.xpath("//div[@data-zh-id=\"192767907615411496385352\"]//li[text() = 'Consumo Per Capita']");

    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoNumeroRequisicao = By.xpath("//div[@id=\"NRREQUEXTR\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoApagarCampoPeriodo = By.xpath("//div[@id=\"DTINTERVAL\"]//span[@zh-icon=\"no-border close-x\"]");
    By botaoAplicarFiltro = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoEditar = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li[1]//div[@class=\"zh-test-box\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li[2]//div[@class=\"zh-test-box\"]");
    By botaoExcluirRequisicao = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoExcluirProduto = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoAcoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoConfirmarAcao = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoCancelarAcao = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoAvancar = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-right\"]");
    By botaoCampoDataAcaoReqExtraAuto = By.xpath("//section[@class=\"zh-field-group\"]//div[@class=\"field-group-rows\"]/div[3]//span[@style=\"background-image: none; display: block;\"]");

    By checkBoxSelecionarTodosProdutosRequisicao = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By reqProdutoCampoQuantidade1 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By campoComensaisAcaoRequisicaoExtraAuto = By.id("P_NRCOMENSAIS");

    By campoNomeProduto = By.id("NMPRODUTO");
    By produtoCreosoto = By.xpath("//div[@data-zh-id=\"192767907628070499095454\"]//span[text() = '1.01.1.1.01.001.00 | CREOSOTO']");
    By campoQuantidade = By.id("QTPREVRETI");
    By campoDataLimiteEntrega = By.id("DTLIMITERETI");
    By botaoCampoDataLimiteEntrega = By.xpath("//div[@data-zh-id=\"192767907636732733445459\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataLimiteEntregaFormProdutoTipoPrato = By.xpath("//div[@data-zh-id=\"192767907619330440881043\"]//span[@style=\"background-image: none; display: block;\"]");
    By dia1 = By.xpath("//div[@class=\"day grid\"]//div[text() = '1']");
    By campoHora = By.id("HRLIMITERETI");

    By abaTipoPrato = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Tipo de Prato']");
    By abaProduto = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produto']");
    By abaMensagem = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Mensagem']");
    By campoMensagem = By.id("DSOBSREQU");
    By checkBoxProdutoCabecalho = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"header\"]//div[@data-zh-field-name=\"__CHECKBOX\"]/div");
    By checkBoxProduto1 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By codigoProduto1 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By nomeProduto1 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By quantidadeProduto1 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[1]/div[4]/span");
    By unidadeProduto1 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[1]/div[5]/span");
    By codigoProduto2 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By nomeProduto2 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[2]/div[3]/span");
    By quantidadeProduto2 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[2]/div[4]/span");
    By unidadeProduto2 = By.xpath("//div[@id=\"grid-192767907632551207835435\"]//div[@class=\"body-content\"]/div[2]/div[5]/span");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");

    By numeroRequisicao = By.xpath("//span[@class=\"stripe-value-NRREQUEXTR\"]");

    By acaoRelatorio = By.xpath("//div[@class=\"container\"]//span[text() = 'Relatório']");
    By acaoProdutosRequisitados = By.xpath("//div[@class=\"container\"]//span[text() = 'Produtos Requisitados']");
    By acaoRequisicaoExtraAutomatica = By.xpath("//div[@class=\"container\"]//span[text() = 'Requisição Extra Automática']");
    By acaoImportacaoConsumoServico = By.xpath("//div[@class=\"container\"]//span[text() = 'Importação de Consumo Por Serviço']");
    By acaoExportarRequisicaoExtra = By.xpath("//div[@class=\"container\"]//span[text() = 'Exportar Requisição Extra']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"19276790762567016171168\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioRequisicaoExtra = By.xpath("//div[@data-zh-id=\"19276790762567016171168\"]//li[text() = 'Requisição Extra']");
    By relatorioRequisicaoExtraTurnos = By.xpath("//div[@data-zh-id=\"19276790762567016171168\"]//li[text() = 'Requisição Extra (Turnos)']");

    By campoOrdenacao = By.xpath("//div[@data-zh-id=\"192767907638888317251172\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By ordenacaoCodigo = By.xpath("//div[@data-zh-id=\"192767907638888317251172\"]//li[text() = 'Código']");
    By ordenacaoAlfabetica = By.xpath("//div[@data-zh-id=\"192767907638888317251172\"]//li[text() = 'Alfabética Pelo Nível']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By campoNiveisOrdenacao = By.xpath("//div[@data-zh-id=\"192767907620258825731174\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By niveisOrdenacao = By.xpath("//div[@data-zh-id=\"192767907620258825731174\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By nivelOrdenacaoSelecionado = By.xpath("//div[@data-zh-id=\"192767907620258825731174\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]/span");

    By unidadeDepositoBc111AcaoProdutosRequisitados = By.xpath("//div[@data-zh-id=\"192767907629744395921145\"]//div[3]//span[text() = '0003 | DEPOSITO BC 111']");
    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");
    By todosServicosAcaoProdutosRequisitados = By.xpath("//label[@for=\"zh-checkbox-ALLCDSERVFILI\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By servicoAlmocoAcaoProdutosRequisitados = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO']");

    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoGuarnicao = By.xpath("//div[@data-zh-id=\"19276790768398180165405\"]//span[text() = '02 | GUARNIÇÃO']");
    By tipoPratoArroz = By.xpath("//div[@data-zh-id=\"19276790768398180165405\"]//span[text() = '01 | ARROZ']");
    By campoNomePrato = By.id("NMPRATO");
    By pratoFeijoadaSimples = By.xpath("//div[@data-zh-id=\"192767907614026300295409\"]//span[text() = '00.00.00.001 | FEIJOADA SIMPLES']");
    By pratoArrozTemperado = By.xpath("//div[@data-zh-id=\"192767907614026300295409\"]//span[text() = '00.00.00.000 | ARROZ TEMPEREADO']");
    By campoProduto = By.id("NMPRODUTO");
    By produtoOleoCopaiba = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE COPAIBA']");
    By produtoOleoDeAmendoasDoces = By.xpath("//div[@data-zh-id=\"192767907613440679005369\"]//span[text() = '1.01.1.1.01.005.00 | OLEO DE AMENDOAS DOCES']");
    By codigoTipoPratoProduto1 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeTipoPratoProduto1 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By quantidadeTipoPratoProduto1 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By dataTipoPratoProduto1 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DTLIMITERETI\"]/span");
    By horaTipoPratoProduto1 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"HRLIMITERETI\"]/span");
    By codigoTipoPratoProduto2 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeTipoPratoProduto2 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By quantidadeTipoPratoProduto2 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By dataTipoPratoProduto2 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"DTLIMITERETI\"]/span");
    By horaTipoPratoProduto2 = By.xpath("//div[@id=\"grid-19276790766172536955367\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"HRLIMITERETI\"]/span");
    By codigoTipoPrato1 = By.xpath("//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By nomeTipoPrato1 = By.xpath("//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By codigoPrato1 = By.xpath("//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By nomePrato1 = By.xpath("//div[@class=\"body-content\"]/div[1]/div[4]/span");
    By codigoTipoPrato2 = By.xpath("//div[@class=\"body-content\"]/div[2]/div[1]/span");
    By nomeTipoPrato2 = By.xpath("//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By codigoPrato2 = By.xpath("//div[@class=\"body-content\"]/div[2]/div[3]/span");
    By nomePrato2 = By.xpath("//div[@class=\"body-content\"]/div[2]/div[4]/span");

    By campoTipoImportacaoConsumoPorServico = By.xpath("//div[@data-zh-id=\"192767907619582611691186\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By tipoImportacaoConsumoFixo = By.xpath("//div[@data-zh-id=\"192767907619582611691186\"]//li[text() = 'Consumo Fixo']");
    By tipoImportacaoConsumoPerCapita = By.xpath("//div[@data-zh-id=\"192767907619582611691186\"]//li[text() = 'Consumo Per Capita']");
    By importacaoConsumoServicoCheckBox = By.xpath("//div[@id=\"grid-192767907624035358091180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By importacaoConsumoServicoCodigoProduto = By.xpath("//div[@id=\"grid-192767907624035358091180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By importacaoConsumoServicoNomeProduto = By.xpath("//div[@id=\"grid-192767907624035358091180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By importacaoConsumoServicoQuantidade = By.xpath("//div[@id=\"grid-192767907624035358091180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTCONSSERV\"]/span");
    By importacaoConsumoServicoUnidade = By.xpath("//div[@id=\"grid-192767907624035358091180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");

    By campoUnidadeExportarRequisicaoExtra = By.id("NMFILIALDESTINO");
    By unidadeDepositoBc111ExportarRequisicao = By.xpath("//div[@data-zh-id=\"19276790763000802913296\"]//span[text() = '0003 | DEPOSITO BC 111']");
    By unidadeDepositoJabaquaraExportarRequisicao = By.xpath("//div[@data-zh-id=\"19276790763000802913296\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By campoServicoExportarRequisicaoExtra = By.id("CDSERVFILIDESTINO");
    By servicoAlmoFitExportarRequisicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO INFT']");
    By servicoPalestraExportarRequisicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'PALESTRA']");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"192767907621794425041053\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"192767907624930802671055\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioData = By.xpath("//div[@data-zh-id=\"19276790769877220841060\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNomeProdutoReqProd = By.xpath("//div[@data-zh-id=\"192767907628070499095454\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeProdutoReqProd = By.xpath("//div[@data-zh-id=\"192767907629418343345457\"]//div[@class=\"zh-validation\"]/span");
    By mensagemobrigatorioDataReqProd = By.xpath("//div[@data-zh-id=\"192767907636732733445459\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioHoraReqProd = By.xpath("//div[@data-zh-id=\"192767907623416620825460\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeAcaoProdRequisitado = By.xpath("//div[@data-zh-id=\"192767907629744395921145\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPeriodoProdRequisitado = By.xpath("//div[@data-zh-id=\"192767907627577075841150\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServicoProdRequisitado = By.xpath("//div[@data-zh-id=\"192767907618735900001151\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNomeTipoPratoAddReqTipoPrato = By.xpath("//div[@data-zh-id=\"19276790768398180165405\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNomePratoAddReqTipoPrato = By.xpath("//div[@data-zh-id=\"192767907614026300295409\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutosAddReqTipoPrato = By.xpath("//div[@data-zh-id=\"192767907627657904161074\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFormProdutoReqTipoPrato = By.xpath("//div[@data-zh-id=\"192767907613440679005369\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeFormprodutoReqTipoPrato = By.xpath("//div[@data-zh-id=\"192767907613440679005369\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataFormProdutoTipoPrato = By.xpath("//div[@data-zh-id=\"192767907619330440881043\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioHoraFormProdutoTipoPrato = By.xpath("//div[@data-zh-id=\"192767907621336321961045\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataAcaoReqExtraAuto = By.xpath("//section[@class=\"zh-field-group\"]//div[@class=\"field-group-rows\"]/div[3]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioComensaisAcaoReqExtraAuto = By.xpath("//section[@class=\"zh-field-group\"]//div[@class=\"field-group-rows\"]/div[4]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioUnidadeAcaoExportarReqExtra = By.xpath("//div[@data-zh-id=\"19276790763000802913296\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServicoAcaoExportarReqExtra = By.xpath("//div[@data-zh-id=\"19276790761331084210301\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Requisição Extra");
        click(telaRequisicaoExtra);
    }

    public void preencherFiltroInicial(String tipoRequisicao, String produtos) {
        tempo();
        tempo();
        tempo();
        if (tipoRequisicao.equals("Tipo de Prato")) {
            clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
            tempo();
            clicarCampoSelecionarValor(campoServico, servicoAlmocoEspecial);
        } else if (tipoRequisicao.equals("Produto")) {
            clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc111);
            tempo();
            clicarCampoSelecionarValor(campoServico, servicoAlmoco);
        }
        preencherProdutosFiltroInicial(produtos);
        click(botaoAplicarFiltro);
    }

    private void preencherProdutosFiltroInicial(String produtos) {
        if (produtos.equals("Matéria Prima")) {
            clicarCampoSelecionarValor(campoProdutosFiltroInicial, produtosMateriaPrima);
        } else if (produtos.equals("Consumo Fixo")) {
            clicarCampoSelecionarValor(campoProdutosFiltroInicial, produtosConsumoFixo);
        } else if (produtos.equals("Consumo Per Capita")) {
            clicarCampoSelecionarValor(campoProdutosFiltroInicial, produtosConsumoPerCapta);
        }
    }

    private void verificarMensagemSalvoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Salvo com sucesso", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");
    }

    private void verificarMensagemExcluidoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Removido com sucesso", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");
    }

    public String addRequisicaoProd() {
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        clicarCampoSelecionarValor(campoNomeProduto, produtoCreosoto);
        sendKeys(campoQuantidade, "7,5");
        click(botaoCampoDataLimiteEntrega);
        click(botaoCampoDataLimiteEntrega);
        click(dia1);
        clearAndSendKeys(campoHora, "07:50");
        String dataSelecionada = getText(campoDataLimiteEntrega);
        click(botaoSalvar);
        tempo();
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();

        return dataSelecionada;
    }

    //o método está incompleto, pois a tela está com erro nesta etapa, quando é adicionado o valor zero deve ser emitida uma mensagem
    //informando que o valor deve ser maior que zero, mas está informando que foi salvo com sucesso e continua com o valor antigo
    public void tentarEditarQuantProdReqProdValorZero() {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(reqProdutoCampoQuantidade1)).click().build().perform();
        tempo();
        actions.sendKeys("0").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();

    }

    public void verificarProdutoAdd(String dataLimite) {
        //valores esperados
        String expCodigo = "1.01.1.1.01.001.00";
        String expNome = "CREOSOTO";
        String expQuantidade = "7,500";
        String expUnidade = "L";

        //valores encontrados
        String encCodigo = getText(codigoProduto1);
        String encNome = getText(nomeProduto1);
        String encQuantidade = getText(quantidadeProduto1);
        String encUnidade = getText(unidadeProduto1);

        Assert.assertEquals(encCodigo, expCodigo, "Verificar o código do produto adicionado na requisição do tipo 'Produto'");
        Assert.assertEquals(encNome, expNome, "Verificar o nome do produto adicionado na requisição do tipo 'Produto'");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificar a quantidade do produto adicionado na requisição do tipo 'Produto'");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar a unidade do produto adicionado na requisição do tipo 'Produto'");

        click(nomeProduto1);
        click(botaoEditar);

        //valores esperados
        String expData = dataLimite;
        String expHora = "07:50";

        //valores encontrados
        String encData = getText(campoDataLimiteEntrega);
        String encHora = driver.findElement(campoHora).getAttribute("value");
        Assert.assertEquals(encData, expData, "Verificar a data do produto adicionado na requisição do tipo 'Produto'");
        Assert.assertEquals(encHora, expHora, "Verificar a hora do produto adicionado na requisição do tipo 'Produto'");
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void verificarProdutoExportado() {
        //valores esperados
        String expCodigo = "1.01.1.1.01.001.00";
        String expNome = "CREOSOTO";
        String expQuantidade = "8,000";
        String expUnidade = "L";

        //valores encontrados
        String encCodigo = getText(codigoProduto1);
        String encNome = getText(nomeProduto1);
        String encQuantidade = getText(quantidadeProduto1);
        String encUnidade = getText(unidadeProduto1);

        Assert.assertEquals(encCodigo, expCodigo, "Verificar o código do produto adicionado na requisição do tipo 'Produto' por meio da ação de 'Exportar Requisição Extra'");
        Assert.assertEquals(encNome, expNome, "Verificar o nome do produto adicionado na requisição do tipo 'Produto' por meio da ação de 'Exportar Requisição Extra'");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificar a quantidade do produto adicionado na requisição do tipo 'Produto' por meio da ação de 'Exportar Requisição Extra'");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar a unidade do produto adicionado na requisição do tipo 'Produto' por meio da ação de 'Exportar Requisição Extra'");

        click(nomeProduto1);
        click(botaoEditar);

        String encData = driver.findElement(campoDataLimiteEntrega).getAttribute("value");
        String encHora = driver.findElement(campoHora).getAttribute("value");

        String expData = "11/06/2023";
        String expHora = "08:15";
        Assert.assertEquals(encData, expData, "Verificar a data do limite de entrega do produto após a alteração da mesma");
        Assert.assertEquals(encHora, expHora, "Verificar a hora do limite de entrega do produto após a alteração da mesma");
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }


    public void editarValoresProduto() {
        tempo();
        Actions actions = new Actions(driver);
        alterarValorCampo(quantidadeProduto1, "8");
        click(botaoSalvarAlteracoes);
        tempo();
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();

        String quantidade = getText(quantidadeProduto1);
        Assert.assertEquals(quantidade, "8,000", "Verificar o valor da quantidade do produto após a alteração da mesma");

        click(nomeProduto1);
        click(botaoEditar);
        click(botaoCampoDataLimiteEntrega);
        actions.moveToElement(driver.findElement(campoDataLimiteEntrega)).click().build().perform();
        sendKeys(campoDataLimiteEntrega, "11/06/2023");
        clearAndSendKeys(campoHora, "08:15");
        click(botaoSalvar);
        tempo();
        tempo();
        click(nomeProduto1);
        click(botaoEditar);
        tempo();

        String encData = driver.findElement(campoDataLimiteEntrega).getAttribute("value");
        String encHora = driver.findElement(campoHora).getAttribute("value");

        String expData = "11/06/2023";
        String expHora = "08:15";
        Assert.assertEquals(encData, expData, "Verificar a data do limite de entrega do produto após a alteração da mesma");
        Assert.assertEquals(encHora, expHora, "Verificar a hora do limite de entrega do produto após a alteração da mesma");
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void excluirProdutoRequisicao() {
        click(checkBoxProdutoCabecalho);
        click(botaoExcluirRequisicao);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta, após solitar a exclusão do produto da requisição");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public void excluirTodosProdutosRequisicao() {
        click(checkBoxSelecionarTodosProdutosRequisicao);
        click(botaoExcluirRequisicao);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta, após solitar a exclusão do produto da requisição");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public String capturarDadosRequisicao() {
        return getText(numeroRequisicao);
    }

    public void filtroInicialParaVerificarRequisicaoAdd(String tipoRequisicao, String nrRequisicao, String produtos) {
        tempo();
        tempo();
        tempo();
        if (tipoRequisicao.equals("Tipo de Prato")) {
            clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
            tempo();
            clicarCampoSelecionarValor(campoServico, servicoAlmocoEspecial);
        } else if (tipoRequisicao.equals("Produto")) {
            tempo();
            clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc111);
            tempo();
            clicarCampoSelecionarValor(campoServico, servicoAlmoco);
        }
        preencherProdutosFiltroInicial(produtos);

        By requisicao = By.xpath("//div[@data-zh-field-name=\"NRREQUEXTR\"]//span[text() = '" + nrRequisicao + "']");
        click(botaoCampoNumeroRequisicao);
        tempo();
        sendKeys(campoProcurarNrRequisicaoFiltroInicial, nrRequisicao);
        tempo();
        tempo();
        click(requisicao);
        tempo();

        click(botaoAplicarFiltro);
    }

    public void adicionarEditarRemoverMensagem(String tipoRequisicao) {
        tempo();
        tempo();
        click(abaMensagem);
        sendKeys(campoMensagem, "Adicionar mensagem automatizada");
        click(botaoSalvar);
        String mensagem = driver.findElement(campoMensagem).getAttribute("value");
        String mensagemEsperada = "Adicionar mensagem automatizada";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem adicionada no campo mensagem");

        tempo();
        tempo();
        clearAndSendKeys(campoMensagem, "Editar mensagem automatizada");
        tempo();
        click(botaoSalvar);
        mensagem = driver.findElement(campoMensagem).getAttribute("value");
        mensagemEsperada = "Editar mensagem automatizada";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem alterada no campo mensagem");

        tempo();
        tempo();
        clearAndSendKeys(campoMensagem, "");
        tempo();
        click(botaoSalvar);
        mensagem = driver.findElement(campoMensagem).getAttribute("value");
        mensagemEsperada = "";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar a mensagem foi apagada corretamente");
        tempo();
        tempo();

        if (tipoRequisicao == "Tipo de Prato") {
            click(abaTipoPrato);
        } else if (tipoRequisicao == "Produto") {
            click(abaProduto);
        }
    }

    public void gerarRelatorioRequisicaoExtra() {
        click(botaoAcoes);
        click(acaoRelatorio);
        clicarCampoSelecionarValor(campoRelatorio, relatorioRequisicaoExtra);
        clicarCampoSelecionarValor(campoOrdenacao, ordenacaoCodigo);
        gerarRelatorio();

        clicarCampoSelecionarValor(campoRelatorio, relatorioRequisicaoExtraTurnos);
        gerarRelatorio();

        clicarCampoSelecionarValor(campoOrdenacao, ordenacaoAlfabetica);
        verificarNiveis();

        cancelarAcaoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    private void verificarNiveis() {
        click(campoNiveisOrdenacao);
        tempo();

        long timeout = 0;
        List<WebElement> results = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                niveisOrdenacao
                        )
                );

        int quantNiveis = 0;
        for (WebElement nivel : results) {
            if (!nivel.getText().isEmpty()) {
                Assert.assertEquals(nivel.getText(), String.valueOf(quantNiveis));
                quantNiveis++;
            }
        }
        Assert.assertEquals(quantNiveis, 7, "Verificar se a quantidade total de níveis corresponde à 5");
        results.get(3).click();
        String nivelSelecionado = getText(nivelOrdenacaoSelecionado);
        Assert.assertEquals(nivelSelecionado, "2", "Verificar o valor do nível selecionado");
    }

    public void gerarRelatorioAcaoProdutosRequisitados() {
        click(botaoAcoes);
        click(acaoProdutosRequisitados);
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc111AcaoProdutosRequisitados);

        super.preencherDatas(campoDataInicial, campoDataFinal, "01/06/2023", "30/06/2023");
        gerarRelatorio();

        click(todosServicosAcaoProdutosRequisitados);
        clicarCampoSelecionarValor(campoServico, servicoAlmocoAcaoProdutosRequisitados);
        click(botaoOk);
        gerarRelatorio();
        cancelarAcaoRelatorio();
    }

    private void gerarRelatorio() {
        tempo();
        tempo();
        click(botaoConfirmarAcao);
        click(tipoPdf);
        tempo();
        click(botaoConfirmarAcao);
        fecharGuiaDoRelatorio();
    }

    private void cancelarAcaoRelatorio() {
        click(botaoCancelarAcao);
        tempo();
        click(botaoCancelarAcao);
        tempo();
    }

    public void addRequisicaoTipoPrato() {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoGuarnicao);
        clicarCampoSelecionarValor(campoNomePrato, pratoFeijoadaSimples);
        click(campoProduto);
        click(produtoOleoCopaiba);
        click(botaoOk);
        click(botaoAvancar);
        tempo();

        alterarValorCampo(quantidadeTipoPratoProduto1, "9");
        tempo();
        click(botaoSalvarAlteracoes);
        tempo();
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
    }

    public void verificarReqTipoPrato() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoTipoPrato1);
        String encNomeTipoPrato = getText(nomeTipoPrato1);
        String encCodigoPrato = getText(codigoPrato1);
        String encNomePrato = getText(nomePrato1);

        //valores esperados
        String expCodigoTipoPrato = "02";
        String expNomeTipoPrato = "GUARNIÇÃO";
        String expCodigoPrato = "00.00.00.001";
        String expNomePrato = "FEIJOADA SIMPLES";

        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificação do código do tipo de prato adicionado na requisição");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificação do nome do tipo de prato adicionado na requisição");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação do código do prato adicionado na requisição");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação do nome do prato adicionado na requisição");
        verificarProdutoAddInicioReqTipoPrato();
    }

    private void verificarReqTipoPratoAposAlteracao() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoTipoPrato1);
        String encNomeTipoPrato = getText(nomeTipoPrato1);
        String encCodigoPrato = getText(codigoPrato1);
        String encNomePrato = getText(nomePrato1);

        //valores esperados
        String expCodigoTipoPrato = "01";
        String expNomeTipoPrato = "ARROZ";
        String expCodigoPrato = "00.00.00.000";
        String expNomePrato = "ARROZ TEMPEREADO";
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificação do código do tipo de prato após a edição da requisição");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificação do nome do tipo de prato após a edição da requisição");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação do código do prato após a edição da requisição");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação do nome do prato após a edição da requisição");
    }

    public void verificarSegundoProdutoAddReqTipoPrato() {
        //valores encontrados
        String encCodigo;
        String encNomeProduto;
        String encQuantidade;
        String encData;
        String encHora;
        if (getText(nomeTipoPratoProduto1).equals("OLEO DE AMENDOAS DOCES")) {
            encCodigo = getText(codigoTipoPratoProduto1);
            encNomeProduto = getText(nomeTipoPratoProduto1);
            encQuantidade = getText(quantidadeTipoPratoProduto1);
            encData = getText(dataTipoPratoProduto1);
            encHora = getText(horaTipoPratoProduto1);
        } else {
            encCodigo = getText(codigoTipoPratoProduto2);
            encNomeProduto = getText(nomeTipoPratoProduto2);
            encQuantidade = getText(quantidadeTipoPratoProduto2);
            encData = getText(dataTipoPratoProduto2);
            encHora = getText(horaTipoPratoProduto2);
        }


        //valores esperados
        String expCodigo = "1.01.1.1.01.005.00";
        String expNomeProduto = "OLEO DE AMENDOAS DOCES";
        String expQuantidade = "5,000";
        String expData = "13/01/2023";
        String expHora = "04:30";
        Assert.assertEquals(encCodigo, expCodigo, "Verificar o código do segundo produto adicionado à requisição de tipo de prato");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar o nome do segundo produto adicionado à requisição de tipo de prato");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificar a quantidade do segundo produto adicionado à requisição de tipo de prato");
        Assert.assertEquals(encData, expData, "Verificar a data do segundo produto adicionado à requisição de tipo de prato");
        Assert.assertEquals(encHora, expHora, "Verificar a hora do segundo produto adicionado à requisição de tipo de prato");
    }

    private void verificarProdutoAddInicioReqTipoPrato() {
        tempo();
        click(nomeTipoPrato1);
        click(abaProduto);
        tempo();
        //valores esperados
        String expCodigoProduto = "1.01.1.1.01.003.00";
        String expNomeProduto = "OLEO DE COPAIBA";
        String expQuantidadeProduto = "9,000";

        //valores encontrados
        String encCodigoProduto = getText(codigoTipoPratoProduto1);
        String encNomeProduto = getText(nomeTipoPratoProduto1);
        String encQuantidadeProduto = getText(quantidadeTipoPratoProduto1);
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar código do produto adicionado na requisição");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar código do nome adicionado na requisição");
        Assert.assertEquals(encQuantidadeProduto, expQuantidadeProduto, "Verificar código do quantidade adicionado na requisição");
    }

    public void verificarReqTipoPratoExportada() {
        verificarReqTipoPratoAposAlteracao();
        tempo();
        click(nomeTipoPrato1);
        click(abaProduto);
        tempo();

        //valores encontrados
        String encCodigo = getText(codigoTipoPratoProduto1);
        String encNomeProduto = getText(nomeTipoPratoProduto1);
        String encQuantidade = getText(quantidadeTipoPratoProduto1);

        //valores esperados
        String expCodigo;
        String expNomeProduto;
        String expQuantidade;

        //valores esperados
        if (encCodigo.equals("1.01.1.1.01.003.00")) {
            expCodigo = "1.01.1.1.01.003.00";
            expNomeProduto = "OLEO DE COPAIBA";
            expQuantidade = "11,000";
        } else {
            expCodigo = "1.01.1.1.01.005.00";
            expNomeProduto = "OLEO DE AMENDOAS DOCES";
            expQuantidade = "5,000";
        }

        Assert.assertEquals(encCodigo, expCodigo, "Verificar o código do produto na requisição exportada");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar o nome do produto na requisição exportada");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificar a quantidade do produto na requisição exportada");
        tempo();
        click(botaoVoltar);
        tempo();
    }

    public void editarReqTipoPrato() {
        tempo();
        click(botaoVoltar);
        tempo();
        click(nomeTipoPrato1);
        tempo();
        click(botaoEditar);
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoArroz);
        clicarCampoSelecionarValor(campoNomePrato, pratoArrozTemperado);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
        click(botaoVoltar);

        verificarReqTipoPratoAposAlteracao();
        verificarProdutoAddInicioReqTipoPrato();
    }

    public void alterarQuantidadeProdutoTipoPrato() {
        alterarValorCampo(quantidadeTipoPratoProduto1, "11");
        tempo();
        click(botaoSalvarAlteracoes);

        tempo();
        tempo();
        tempo();
        tempo();
        click(nomeTipoPrato1);
        tempo();
        click(abaProduto);
        String encQuantidade = getText(quantidadeTipoPratoProduto1);
        String expQuantidade = "11,000";
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação da quantidade do produto após a alteração do mesmo, na requisição de tipo de prato");
    }

    public void addSegundoProdutoReqTipoPrato()  {
        Actions actions = new Actions(driver);

        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoProduto, produtoOleoDeAmendoasDoces);
        sendKeys(campoQuantidade, "0");
        click(botaoSalvar);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade deve ser maior que zero";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela quando tenta adicionar um produto com quantidade 0 na requisição de tipo de prato");
        click(botaoOkAlerta);
        clearAndSendKeys(campoQuantidade, "5");
        clearAndSendKeys(campoHora, "09:00");
        tempo();
        click(botaoSalvar);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Hora limite deve ser menor ou igual ao início de preparo (05:00)";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela quando tenta adicionar um produto com a hora maior que a hora de início do preparo");
        click(botaoOkAlerta);


        tempo();
        click(botaoCampoDataLimiteEntregaFormProdutoTipoPrato);
        actions.moveToElement(driver.findElement(campoDataLimiteEntrega)).click().build().perform();
        sendKeys(campoDataLimiteEntrega, "13/01/2023");
        clearAndSendKeys(campoHora, "04:30");
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
        tempo();
        verificarSegundoProdutoAddReqTipoPrato();
    }

    public void tentarEditarQuantProdTipoPratoValorZero() {
        alterarValorCampo(quantidadeTipoPratoProduto2, "0");
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Os campos de quantidade devem ser maiores que zero.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar editar a quantidade do produto para o valor 0");
        click(botaoOkAlerta);
        click(botaoCancelar);
        tempo();
        click(nomeTipoPrato1);
        click(abaProduto);
    }

    public void removerProdutoReqTipoPrato() {
        click(nomeTipoPratoProduto1);
        tempo();
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta, após solitar a exclusão do produto da requisição");
        tempo();
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public void removerRequisicaoTipoPrato() {
        tempo();
        click(nomeTipoPrato1);
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta, após solitar a exclusão da requisição de tipo de prato");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public void removerRequisicaoTipoPratoImportada() {
        tempo();
        click(nomeTipoPrato2);
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta, após solitar a exclusão da requisição de tipo de prato");
        click(botaoSim);
        verificarMensagemExcluidoSucessoNoCantoSuperiorDireito();
    }

    public void campoObrigatoriosFiltroInicial() {
        click(unidadeDepositoBc111);
        tempo();
        click(botaoCampoUnidade);
        tempo();
        click(botaoAplicarFiltro);

        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String data = getText(mensagemObrigatorioData);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'unidade' no filtro inicial da tela");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'serviço' no filtro inicial da tela");
        Assert.assertEquals(data, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'data' no filtro inicial da tela");
    }

    public void camposObrigatorioAddReqProduto() {
        tempo();
        click(botaoAdicionar);
        click(botaoCampoDataLimiteEntrega);
        clear(campoHora);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Hora inválida!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após apagar a hora e tentar salvar a requisição");
        click(botaoOkAlerta);
        click(botaoSalvar);

        String nomeProduto = getText(mensagemObrigatorioNomeProdutoReqProd);
        String quantidade = getText(mensagemObrigatorioQuantidadeProdutoReqProd);
        String data = getText(mensagemobrigatorioDataReqProd);
        String hora = getText(mensagemObrigatorioHoraReqProd);
        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(nomeProduto, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'nome do produto' no formulário para adicionar um requisição de produto");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'quantidade' no formulário para adicionar um requisição de produto");
        Assert.assertEquals(data, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'data' no formulário para adicionar um requisição de produto");
        Assert.assertEquals(hora, mensagemEsperada, "Verificar mensagem de campo obrigatório, no campo 'hora' no formulário para adicionar um requisição de produto");
        click(botaoCancelar);
    }

    public void camposObrigatoriosAcaoProdutosRequisitados() {
        click(botaoAcoes);
        click(acaoProdutosRequisitados);
        click(botaoCampoUnidade);
        click(botaoApagarCampoPeriodo);
        click(todosServicosAcaoProdutosRequisitados);
        click(botaoConfirmarAcao);

        String unidade = getText(mensagemObrigatorioUnidadeAcaoProdRequisitado);
        String periodo = getText(mensagemObrigatorioPeriodoProdRequisitado);
        String servico = getText(mensagemObrigatorioServicoProdRequisitado);
        String mensagemEsperadaData = "Período é obrigatório!";
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo unidade, na ação 'produtos requisitados'");
        Assert.assertEquals(periodo, mensagemEsperadaData, "Verificar mensagem de campo obrigatório no campo período, na ação 'produtos requisitados'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo servico, na ação 'produtos requisitados'");
        click(botaoCancelarAcao);
        tempo();
        click(botaoCancelarAcao);
        tempo();
    }

    public void camposObrigatoriosAddTipoPrato() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoAvancar);

        String nomeTipoPrato = getText(mensagemObrigatorioNomeTipoPratoAddReqTipoPrato);
        String nomePrato = getText(mensagemObrigatorioNomePratoAddReqTipoPrato);
        String produto = getText(mensagemObrigatorioProdutosAddReqTipoPrato);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(nomeTipoPrato, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo nome tipo prato, no formulário para adicionar um tipo de prato na requisição");
        Assert.assertEquals(nomePrato, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo nome prato, no formulário para adicionar um tipo de prato na requisição");
        Assert.assertEquals(produto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo produtos, no formulário para adicionar um tipo de prato na requisição");
    }

    public void camposObrigatorioFormProdutoReqTipoPrato() {
        tempo();
        click(botaoAdicionar);
        tempo();
        tempo();
        click(botaoCampoDataLimiteEntregaFormProdutoTipoPrato);
        clear(campoHora);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Hora inválida!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após apagar a hora e tentar salvar a requisição");
        click(botaoOkAlerta);
        tempo();
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProdutoFormProdutoReqTipoPrato);
        String quantidade = getText(mensagemObrigatorioQuantidadeFormprodutoReqTipoPrato);
        String data = getText(mensagemObrigatorioDataFormProdutoTipoPrato);
        String hora = getText(mensagemObrigatorioHoraFormProdutoTipoPrato);

        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'nome de produto', no formulário para adicionar um produto à requisição de tipo de prato");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'quantidade', no formulário para adicionar um produto à requisição de tipo de prato");
        Assert.assertEquals(data, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'data', no formulário para adicionar um produto à requisição de tipo de prato");
        Assert.assertEquals(hora, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'hora', no formulário para adicionar um produto à requisição de tipo de prato");
        click(botaoCancelar);
        tempo();
    }

    public void camposObrigatoriosAcaoReqExtraAuto() {
        click(botaoAcoes);
        click(acaoRequisicaoExtraAutomatica);
        click(botaoCampoDataAcaoReqExtraAuto);
        click(botaoConfirmarAcao);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Preencha os campos obrigatórios";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após tentar confirmar a ação de Requisição Extra Automática, sem data e comensais");
        click(botaoOkAlerta);

        String data = getText(mensagemObrigatorioDataAcaoReqExtraAuto);
        String comensais = getText(mensagemObrigatorioComensaisAcaoReqExtraAuto);
        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(data, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'data' na ação de Requisição Extra Automática");
        Assert.assertEquals(comensais, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'comensais' na ação de Requisição Extra Automática");
        click(botaoCancelarAcao);
        tempo();
        click(botaoCancelarAcao);
        tempo();
    }

    public void camposObrigatorioAcaoExportarReqExtra() {
        click(botaoAcoes);
        click(acaoExportarRequisicaoExtra);
        tempo();
        click(botaoConfirmarAcao);
        tempo();

        String unidade = getText(mensagemObrigatorioUnidadeAcaoExportarReqExtra);
        String servico = getText(mensagemObrigatorioServicoAcaoExportarReqExtra);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade' da ação Exportar Requisição Extra");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'serviço' da ação Exportar Requisição Extra");
        tempo();
        click(botaoCancelarAcao);
        tempo();
        click(botaoCancelarAcao);
    }

    public void importarConsumoPorServicoRequisicaoProduto(String tipo) {
        tempo();
        tempo();
        click(botaoAcoes);
        click(acaoImportacaoConsumoServico);
        tempo();

        if (tipo.equals("Consumo Fixo")) clicarCampoSelecionarValor(campoTipoImportacaoConsumoPorServico, tipoImportacaoConsumoFixo);
        else if (tipo.equals("Consumo Per Capita")) clicarCampoSelecionarValor(campoTipoImportacaoConsumoPorServico, tipoImportacaoConsumoPerCapita);

        String codigoProdutoSelecionado = getText(importacaoConsumoServicoCodigoProduto);
        String nomeProdutoSelecionado = getText(importacaoConsumoServicoNomeProduto);
        String quantidadeProdutoSelecionado = getText(importacaoConsumoServicoQuantidade);
        quantidadeProdutoSelecionado = quantidadeProdutoSelecionado.substring(0, quantidadeProdutoSelecionado.length() - 1);
        String unidadeProdutoSelecionado = getText(importacaoConsumoServicoUnidade);

        click(importacaoConsumoServicoCheckBox);
        click(botaoConfirmarAcao);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Importado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após confirmar a importação do consumo por serviço");
        click(botaoOkAlerta);
        click(botaoCancelarAcao);
        tempo();

        String codigoProdutoImportado = getText(codigoProduto2);
        String nomeProdutoImportado = getText(nomeProduto2);
        String quantidadeProdutoImportado = getText(quantidadeProduto2);
        String unidadeProdutoImportado = getText(unidadeProduto2);

        Assert.assertEquals(codigoProdutoImportado, codigoProdutoSelecionado, "Verificar se o código do produto importado é o mesmo do produto que foi selecionado");
        Assert.assertEquals(nomeProdutoImportado, nomeProdutoSelecionado,"Verificar se o nome do produto importado é o mesmo do produto que foi selecionado");
        Assert.assertEquals(quantidadeProdutoImportado, quantidadeProdutoSelecionado, "Verificar se a quantidade do produto importado é a mesma do produto que foi selecionado");
        Assert.assertEquals(unidadeProdutoImportado, unidadeProdutoSelecionado, "Verificar se a unidade do produto importado é a mesma do produto que foi selecionado");
    }

    public void importarConsumoPorServicoRequisicaoTipoPrato(String tipo) {
        tempo();
        tempo();
        click(botaoAcoes);
        click(acaoImportacaoConsumoServico);
        tempo();

        if (tipo.equals("Consumo Fixo")) clicarCampoSelecionarValor(campoTipoImportacaoConsumoPorServico, tipoImportacaoConsumoFixo);
        else if (tipo.equals("Consumo Per Capita")) clicarCampoSelecionarValor(campoTipoImportacaoConsumoPorServico, tipoImportacaoConsumoPerCapita);

        //valores do produto que será importado
        String codigoProdutoSelecionado = getText(importacaoConsumoServicoCodigoProduto);
        String nomeProdutoSelecionado = getText(importacaoConsumoServicoNomeProduto);
        String quantidadeProdutoSelecionado = getText(importacaoConsumoServicoQuantidade);
        quantidadeProdutoSelecionado = quantidadeProdutoSelecionado.substring(0, quantidadeProdutoSelecionado.length() - 1);

        click(importacaoConsumoServicoCheckBox);
        click(botaoConfirmarAcao);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Importado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após confirmar a importação do consumo por serviço");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelarAcao);
        tempo();

        //valores encontrados do tipo de prato importado
        String encCodigoTipoPrato = getText(codigoTipoPrato2);
        String encNomeTipoPrato = getText(nomeTipoPrato2);
        String encCodigoPrato = getText(codigoPrato2);
        String encNomePrato = getText(nomePrato2);

        //valores esperados do tipo de prato importado
        String expCodigoTipoPrato = "";
        String expNomeTipoPrato = "";
        String expCodigoPrato = "";
        String expNomePrato = "";
        switch (tipo) {
            case "Consumo Fixo":
                expCodigoTipoPrato = "04";
                expNomeTipoPrato = "PRATO PRINCIPAL";
                expCodigoPrato = "00.00.00.001";
                expNomePrato = "FEIJOADA SIMPLES";
                break;
            case "Consumo Per Capita":
                expCodigoTipoPrato = "02";
                expNomeTipoPrato = "GUARNIÇÃO";
                expCodigoPrato = "00.00.00.004";
                expNomePrato = "FEIJAO";
                break;
        }
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificar código do tipo de prato importado no consumo por serviço");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificar nome do tipo de prato importado no consumo por serviço");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificar código do prato importado no consumo por serviço");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar nome do prato importado no consumo por serviço");

        click(nomeTipoPrato2);
        click(abaProduto);
        //valores encontrados do produto importado no consumo por serviço
        String codigoProdutoImportado = getText(codigoTipoPratoProduto1);
        String nomeProdutoImportado = getText(nomeTipoPratoProduto1);
        String quantidadeProdutoImportado = getText(quantidadeTipoPratoProduto1);

        Assert.assertEquals(codigoProdutoImportado, codigoProdutoSelecionado, "Verificar se o código do produto importado é o mesmo do produto que foi selecionado");
        Assert.assertEquals(nomeProdutoImportado, nomeProdutoSelecionado,"Verificar se o nome do produto importado é o mesmo do produto que foi selecionado");
        Assert.assertEquals(quantidadeProdutoImportado, quantidadeProdutoSelecionado, "Verificar se a quantidade do produto importado é a mesma do produto que foi selecionado");
        click(botaoVoltar);
    }

    public String requisicaoExtraAuto(String nrRequisicao) {
        tempo();
        click(botaoAcoes);
        click(acaoRequisicaoExtraAutomatica);
        tempo();
        sendKeys(campoComensaisAcaoRequisicaoExtraAuto, "90");
        tempo();
        click(botaoConfirmarAcao);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Requisição gerada com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após a geração da requisição extra automática");
        click(botaoOkAlerta);
        click(botaoCancelarAcao);

        int requisicao = Integer.parseInt(nrRequisicao) + 2;
        nrRequisicao = String.valueOf(requisicao);
        return StringUtils.leftPad(nrRequisicao, 10, "0");
    }

    public String exportarRequisicaoProduto(String nrRequisicao) {
        tempo();
        click(botaoAcoes);
        tempo();
        click(acaoExportarRequisicaoExtra);
        tempo();
        clicarCampoSelecionarValor(campoUnidadeExportarRequisicaoExtra, unidadeDepositoBc111ExportarRequisicao);
        tempo();
        click(campoServicoExportarRequisicaoExtra);
        tempo();
        click(servicoAlmoFitExportarRequisicao);
        click(botaoOk);
        tempo();
        click(botaoConfirmarAcao);
        tempo();

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Exportado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após exportar a exquisição");
        click(botaoOkAlerta);

        int requisicao = Integer.parseInt(nrRequisicao) + 1;
        nrRequisicao = String.valueOf(requisicao);
        tempo();
        return StringUtils.leftPad(nrRequisicao, 10, "0");
    }

    public String exportarRequisicaoTipoPrato(String nrRequisicao, String tipoProduto) {
        tempo();
        click(botaoAcoes);
        click(acaoExportarRequisicaoExtra);
        tempo();
        clicarCampoSelecionarValor(campoUnidadeExportarRequisicaoExtra, unidadeDepositoJabaquaraExportarRequisicao);
        tempo();
        click(campoServicoExportarRequisicaoExtra);
        tempo();
        click(servicoPalestraExportarRequisicao);
        tempo();
        click(botaoOk);
        tempo();
        click(botaoConfirmarAcao);
        tempo();

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Exportado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após exportar a exquisição");
        click(botaoOkAlerta);
        tempo();
        tempo();

        int requisicao;
        if (tipoProduto.equals("Matéria Prima")) requisicao = Integer.parseInt(nrRequisicao) + 1;
        else requisicao = Integer.parseInt(nrRequisicao) + 1;
        nrRequisicao = String.valueOf(requisicao);
        return StringUtils.leftPad(nrRequisicao, 10, "0");
    }

    private void alterarValorCampo(By campo, String valor) {
        Actions actions = new Actions(driver);
        tempo();
        actions.moveToElement(driver.findElement(campo)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }


}
