package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class RequisicaoPorServicoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRequisicaoPorServico = By.xpath("//span[text() = 'Requisição por Serviço']");

    By campoUnidadeFiltroIni = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By unidadeDepositoBC111 = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//span[text() = '0003 | DEPOSITO BC 111']");

    By campoServicoFiltroIni = By.id("NMSERVICO");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-id=\"19777484934037010406485\"]//span[text() = '00002 | ALMOÇO ESPECIAL']");
    By servicoAlmoco = By.xpath("//div[@data-zh-id=\"19777484934037010406485\"]//span[text() = '00003 | ALMOÇO']");

    By campoProdutosFiltroIni = By.xpath("//div[@data-zh-id=\"1977748493180397912489\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By produtoMateriaPrimaFiltroIni = By.xpath("//div[@data-zh-id=\"1977748493180397912489\"]//li[text() = 'Matéria Prima']");
    By produtoConsumoFixoFiltroIni = By.xpath("//div[@data-zh-id=\"1977748493180397912489\"]//li[text() = 'Consumo Fixo']");
    By produtoConsumoPerCapitaFiltroIni = By.xpath("//div[@data-zh-id=\"1977748493180397912489\"]//li[text() = 'Consumo Per Capita']");
    By dataFiltroIni = By.id("DTPREVRETI");

    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoArroz = By.xpath("//div[@data-zh-id=\"19777484932590360782360\"]//span[text() = '01 | ARROZ']");
    By campoPrato = By.id("NMPRATO");
    By pratoArrozTemperado = By.xpath("//div[@data-zh-id=\"19777484933140944423363\"]//span[text() = '00.00.00.000 | ARROZ TEMPEREADO | P']");
    By campoProduto = By.id("NMPRODUTO");
    By produtoOleoAmendoasReqTipoPrato = By.xpath("//div[@data-zh-id=\"19777484933201277115368\"]//span[text() = '1.01.1.1.01.005.00 | OLEO DE AMENDOAS DOCES | L']");
    By produtoOleoAmedasReqTipoPratoProdJaCad = By.xpath("//div[@data-zh-id=\"1977748493730915419407\"]//span[text() = '1.01.1.1.01.005.00 | OLEO DE AMENDOAS DOCES | L']");
    By produtoCanforaReqTipoPrato = By.xpath("//div[@data-zh-id=\"1977748493730915419407\"]//span[text() = '1.01.1.1.02.004.00 | CANFORA | KG']");
    By produtoCreosotoReqProduto = By.xpath("//div[@data-zh-id=\"19777484931087234057553\"]//span[text() = '1.01.1.1.01.001.00 | CREOSOTO | L']");
    By produtoQuerosenaReqProduto = By.xpath("//div[@data-zh-id=\"19777484931087234057553\"]//span[text() = '1.01.1.1.01.004.00 | QUEROSENE | L']");
    By campoQuantExtra = By.id("QTPREVEXTRA");
    By campoQuantDevolvida = By.id("QTPREVDEVOL");
    By campoHoraLimite = By.id("HRLIMITERETI");

    By abaMensagem = By.xpath("//div[@class=\"zh-tab-wrapper\"]//a[text() = 'Mensagem']");
    By campoMensagem = By.id("DSOBSREQU");

    By botaoAplicarFiltro = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoCampoUnidadeFiltroIni = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataFiltroIni = By.xpath("//div[@data-zh-id=\"19777484934206645572492\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoAdicionarRequisicao = By.xpath("//div[@class=\"zh-footer-center\"]//li[1]");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li");
    By botaoCalcular = By.xpath("//div[@class=\"zh-footer-center\"]//li[2]");
    By botaoCampoDataLimiteFormAddReqTipoPrato = By.xpath("//div[@data-zh-id=\"19777484931466902255383\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataLimiteFormAddReqProduto = By.xpath("//div[@data-zh-id=\"19777484933683937040572\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[1]");
    By botaoAcessarTelaRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoSelecionar = By.xpath("//div[@class=\"dwbw dwb-s\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']/div");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By checkBoxTodasReqTipoPrato = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"header-content\"]//div[@class=\"zh-theader zh-ripple-effect\"]");
    By checkBoxReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDTIPOPRAT\"]/span");
    By nomeTipoPratoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMTIPOPRAT\"]/span");
    By codigoPratoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDPRATO\"]/span");
    By nomePratoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRATO\"]/span");

    By checkBoxProdutoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProdutoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevProdutoReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By quantExtraReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVEXTRA\"]/span");
    By quantDevolvidaReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVDEVOL\"]/span");
    By quantLiberadaReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVLIB\"]/span");
    By dataLimiteReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DTLIMITERETI\"]/span");
    By horaLimiteReqTipoPrato1 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"HRLIMITERETI\"]/span");
    By checkBoxProdutoReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProdutoReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevProdutoReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By quantExtraReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVEXTRA\"]/span");
    By quantDevolvidaReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVDEVOL\"]/span");
    By quantLiberadaReqTipoPrato2 = By.xpath("//div[@id=\"grid-19777484932730716086392\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVLIB\"]/span");

    By checkBoxTodasReqProduto = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"header-content\"]//div[@class=\"zh-theader zh-ripple-effect\"]");
    By checkBoxProdutoReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProdutoReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevistaReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By quantExtraReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVEXTRA\"]/span");
    By quantDevolvidaReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVDEVOL\"]/span");
    By quantLiberadaReqProd1 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVLIB\"]/span");
    By checkBoxProdutoReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProdutoReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevistaReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVRETI\"]/span");
    By quantExtraReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVEXTRA\"]/span");
    By quantDevolvidaReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVDEVOL\"]/span");
    By quantLiberadaReqProd2 = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVLIB\"]/span");

    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioRequisicaoServico = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço']");
    By relatorioTurnos = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço (Turnos)']");
    By relatorioRequisicaoOperador = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Operador']");
    By relatorioServicoPontoEntrega = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço/Ponto de Entrega (Analítico)']");
    By relatorioGrupoServicoSintetico = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Grupo de Serviço (Sintético)']");
    By relatorioTipoPrato = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço (Tipo de Prato/Prato)']");
    By relatorioUnidadeAdicional = By.xpath("//div[@data-zh-id=\"211554382912850572345219\"]//span[text() = 'Requisição por Serviço (Unidade Adicional)']");

    By campoDataInicialRel = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");
    By campoUnidadeRel = By.id("NMFILIAL");
    By unidadeDepositoBC129telaRel = By.xpath("//div[@data-zh-id=\"211554382920669148555223\"]//span[text() = '9999 | DEPOSITO BC 129']");
    By checkBoxTodosGrupoServico = By.xpath("//label[@for=\"zh-checkbox-Todos_GrupServ\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoGrupoServicoRel = By.id("CDGRUPSERV");
    By grupoServicoGeral = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'GERAL']");
    By grupoServicoPreparos = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'PREPAROS']");
    By grupoServicoTransp = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'TRANSP.']");

    By checkBoxTodosServico = By.xpath("//label[@for=\"zh-checkbox-Todos_Servico\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoServicoRel = By.id("NMSERVICO");
    By servicoJantaRel = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTA']");
    By servicoRefeicoesTranportadasRel = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'REFEIÇÕES TRANSPORTADAS']");

    By checkBoxTodosPontoEntrega = By.xpath("//label[@for=\"zh-checkbox-Todos_Ptentrega\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoPontoEntregaRel = By.id("NMPTENTREGA");
    By pontoDeEntregaRestauranteNormas = By.xpath("//div[@data-zh-field-name=\"NMPTENTREGA\"]//span[text() = 'RESTAURANTE NORMAS']");

    By checkBoxTodosTiposDeConsumo = By.xpath("//label[@for=\"zh-checkbox-Todos_TipoConsumo\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoTiposDeConsumoRel = By.id("IDConsumo");
    By tipoConsumoMateriaPrimaRel = By.xpath("//div[@data-zh-field-name=\"NMConsumo\"]//span[text() = 'Matéria Prima']");

    By inputCheckBoxGrupoServico = By.id("zh-checkbox-Todos_GrupServ");
    By inputCheckBoxServico = By.id("zh-checkbox-Todos_Servico");
    By inputCheckBoxPontoEntrega = By.id("zh-checkbox-Todos_Ptentrega");
    By inputCheckBoxCalcularAntesDeImprimir = By.id("zh-checkbox-CALCANTES");
    By inputCheckBoxImprimirCardapio = By.id("zh-checkbox-IDIMPRIMECARD");
    By inputCheckBoxArredondarQuantProdutos = By.id("zh-checkbox-ARREDQTD");
    By inputCheckBoxQuebraPagina = By.id("zh-checkbox-QUEBRAPAG");
    By inputCheckBoxImprimirLinhasBranco = By.id("zh-checkbox-LINHABR");
    By inputCheckBoxTiposConsumo = By.id("zh-checkbox-Todos_TipoConsumo");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemObrigatorioUnidadeFiltroIni = By.xpath("//div[@data-zh-id=\"19777484933696712569481\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServicoFiltroIni = By.xpath("//div[@data-zh-id=\"19777484934037010406485\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataFiltroIni = By.xpath("//div[@data-zh-id=\"19777484934206645572492\"]//div[@class=\"zh-validation\"]/span");
    By mensagemNaoHaRegistrosGridTipoPrato = By.xpath("//div[@id=\"grid-19777484933867646281337\"]//div[@class=\"body-content\"]//p");
    By mensagemNaoHaRegistrosGridProdutos = By.xpath("//div[@id=\"grid-1977748493450785601527\"]//div[@class=\"body-content\"]//p");
    By mensagemObrigatorioTipoPratoFormTipoPrato = By.xpath("//div[@data-zh-id=\"19777484932590360782360\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPratoFormTipoPrato = By.xpath("//div[@data-zh-id=\"19777484933140944423363\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFormTipoPrato = By.xpath("//div[@data-zh-id=\"19777484933201277115368\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataLimiteFormTipoPrato = By.xpath("//div[@data-zh-id=\"19777484931466902255383\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioHoraLimiteFormTipoPrato = By.xpath("//div[@data-zh-id=\"19777484933239943712385\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFormProduto = By.xpath("//div[@data-zh-id=\"19777484931087234057553\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataLimiteFormProduto = By.xpath("//div[@data-zh-id=\"19777484933683937040572\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioHoraLimiteFormProduto = By.xpath("//div[@data-zh-id=\"1977748493348020175575\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Requisição por Serviço");
        click(telaRequisicaoPorServico);
    }

    public void preencherFiltroInicial(String tipoRequisicao, String produtos) {
        tempo();
        //selecionar unidade e serviço
        if (tipoRequisicao.equals("Tipo de Prato")) {
            clicarCampoSelecionarValor(campoUnidadeFiltroIni, unidadeDepositoJabaquara);
            clicarCampoSelecionarValor(campoServicoFiltroIni, servicoAlmocoEspecial);
        } else if (tipoRequisicao.equals("Produto")) {
            clicarCampoSelecionarValor(campoUnidadeFiltroIni, unidadeDepositoBC111);
            clicarCampoSelecionarValor(campoServicoFiltroIni, servicoAlmoco);
        }

        //selecionar produto
        if (produtos.equals("Matéria Prima")) {
            clicarCampoSelecionarValor(campoProdutosFiltroIni, produtoMateriaPrimaFiltroIni);
        } else if (produtos.equals("Consumo Fixo")) {
            clicarCampoSelecionarValor(campoProdutosFiltroIni, produtoConsumoFixoFiltroIni);
        } else if (produtos.equals("Consumo Per Capita")) {
            clicarCampoSelecionarValor(campoProdutosFiltroIni, produtoConsumoPerCapitaFiltroIni);
        }


        click(botaoCampoDataFiltroIni);
        click(dataFiltroIni);
        sendKeys(dataFiltroIni, "21/08/2022");
        click(botaoAplicarFiltro);
    }

    public void preencherFiltroInicialParaCalcular(String tipoRequisicao, String produtos) {
        tempo();

        //selecionar unidade e serviço
        if (tipoRequisicao.equals("Tipo de Prato")) {
            clicarCampoSelecionarValor(campoUnidadeFiltroIni, unidadeDepositoJabaquara);
            clicarCampoSelecionarValor(campoServicoFiltroIni, servicoAlmocoEspecial);
        } else if (tipoRequisicao.equals("Produto")) {
            clicarCampoSelecionarValor(campoUnidadeFiltroIni, unidadeDepositoBC111);
            clicarCampoSelecionarValor(campoServicoFiltroIni, servicoAlmoco);
        }

        //selecionar produto
        if (produtos.equals("Matéria Prima")) {
            clicarCampoSelecionarValor(campoProdutosFiltroIni, produtoMateriaPrimaFiltroIni);
        } else if (produtos.equals("Consumo Fixo")) {
            clicarCampoSelecionarValor(campoProdutosFiltroIni, produtoConsumoFixoFiltroIni);
        } else if (produtos.equals("Consumo Per Capita")) {
            clicarCampoSelecionarValor(campoProdutosFiltroIni, produtoConsumoPerCapitaFiltroIni);
        }


        click(botaoCampoDataFiltroIni);
        click(dataFiltroIni);
        sendKeys(dataFiltroIni, "11/12/2023");
        click(botaoAplicarFiltro);
    }

    public void addRequisicaoTipoPrato() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarRequisicao);
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoArroz);
        clicarCampoSelecionarValor(campoPrato, pratoArrozTemperado);
        clicarCampoSelecionarValor(campoProduto, produtoOleoAmendoasReqTipoPrato);
        tempo();
        sendKeys(campoQuantExtra, "8");
        click(campoQuantDevolvida);
        clearAndSendKeys(campoQuantDevolvida, "3");
        click(campoHoraLimite);
        sendKeys(campoHoraLimite, "08:00");
        click(botaoSalvar);
        tempo();


        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela, após adicioanr uma nova requisição");
    }

    public void verificarReqTipoPratoAdd() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoReqTipoPrato1);
        String encNomeTipoPrato = getText(nomeTipoPratoReqTipoPrato1);
        String encCodigoPrato = getText(codigoPratoReqTipoPrato1);
        String encNomePrato = getText(nomePratoReqTipoPrato1);

        //valores esperados
        String expCodigoTipoPrato = "01";
        String expNomeTpoPrato = "ARROZ";
        String expCodigoPrato = "00.00.00.000";
        String expNomePrato = "ARROZ TEMPEREADO";
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificar o código do 'tipo de prato' da requisição tipo de prato adicionada");
        Assert.assertEquals(encNomeTipoPrato, expNomeTpoPrato, "Verificar o código do 'nome ddo tipo de prato' da requisição tipo de prato adicionada");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificar o código do 'código do prato' da requisição tipo de prato adicionada");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar o código do 'nome do prato' da requisição tipo de prato adicionada");

        click(nomeTipoPratoReqTipoPrato1);
        //valores encontrados
        String encCodigoProduto = getText(codigoProdutoReqTipoPrato1);
        String encNomeProduto = getText(nomeProdutoReqTipoPrato1);
        String encUnidade = getText(unidadeProdutoReqTipoPrato1);
        String encQuantPrevista = getText(quantPrevProdutoReqTipoPrato1);
        String encQuantExtra = getText(quantExtraReqTipoPrato1);
        String encQuantDevolvida = getText(quantDevolvidaReqTipoPrato1);
        String encQuantLiberada = getText(quantLiberadaReqTipoPrato1);
        String encDataLimite = getText(dataLimiteReqTipoPrato1);
        String encHoraLimite = getText(horaLimiteReqTipoPrato1);

        //valores esperados
        String expCodigoProduto = "1.01.1.1.01.005.00";
        String expNomeProduto = "OLEO DE AMENDOAS DOCES";
        String expUnidade = "L";
        String expQuantPrevista = "0,000";
        String expQuantExtra = "8,000";
        String expQuantDevolvida = "3,000";
        String expQuantLiberada = "5,000";
        String expDataLimite = "15/09/2023";
        String expHoraLimite = "08:00";

        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar 'nome' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'quantidade prevista' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'quantidade extra' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'quantidade devolvida' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificar 'quantidade liberada' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encDataLimite, expDataLimite, "Verificar 'data limite' do produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encHoraLimite, expHoraLimite, "Verificar 'hora limite' do produto adicionado na requisição de tipo de prato");
        click(botaoVoltar);
    }

    public void addSegundaProdutoReqTipoPrato() {
        tempo();
        click(nomeTipoPratoReqTipoPrato1);
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoProduto, produtoCanforaReqTipoPrato);
        sendKeys(campoQuantExtra, "5");
        click(campoQuantDevolvida);
        clearAndSendKeys(campoQuantDevolvida, "1");
        click(campoHoraLimite);
        click(botaoSelecionar);
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela, após adicioanr um segundo produto à querisição");
    }

    public void verificarSegundaProdutoAddTipoPrato() {
        tempo();
        //valores encontrados
        String encCodigo = getText(codigoProdutoReqTipoPrato2);
        String encNome = getText(nomeProdutoReqTipoPrato2);
        String encUnidade = getText(unidadeProdutoReqTipoPrato2);
        String encQuantPrev = getText(quantPrevProdutoReqTipoPrato2);
        String encQuantExtra = getText(quantExtraReqTipoPrato2);
        String encQuantDevolvida = getText(quantDevolvidaReqTipoPrato2);
        String encQuantLiberada = getText(quantLiberadaReqTipoPrato2);

        //valores esperados
        String expCodigo = "1.01.1.1.02.004.00";
        String expNome = "CANFORA";
        String expUnidade = "KG";
        String expQuantPrev = "0,000";
        String expQuantExtra = "5,000";
        String expQuantDevolvida = "1,000";
        String expQuantLiberada = "4,000";

        Assert.assertEquals(encCodigo, expCodigo, "Verificar 'código' do segundo produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encNome, expNome, "Verificar 'nome' do segundo produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do segundo produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantPrev, expQuantPrev, "Verificar 'qtde. prevista' do segundo produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qtde. extra' do segundo produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qtde. devolvida' do segundo produto adicionado na requisição de tipo de prato");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificar 'qtde. liberada' do segundo produto adicionado na requisição de tipo de prato");
    }

    public void excluirSegundoProdReqTipoPrato() {
        tempo();
        click(checkBoxProdutoReqTipoPrato2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão do(s) produto(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o segundo produto adicionado na requisição de tipo de prato");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após excluir um produto da requisição tipo de prato");

        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-19777484932730716086392 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "1", "Verificar quantidade de produtos na requisição, após a exclusão do segundo produto");
    }

    public void alterarQuantProdReqTipoPrato() {
        tempo();
        alterarValorDoCampo(quantExtraReqTipoPrato1, "11");
        alterarValorDoCampo(quantDevolvidaReqTipoPrato1, "2,5");
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após alterar as quantidade do produto ba requisição de tipo de prato");

        //valores encontrados após a alteração nas quantidades
        String encQuantExtra = getText(quantExtraReqTipoPrato1);
        String encQuantDevolvida = getText(quantDevolvidaReqTipoPrato1);
        String encQuantLiberada = getText(quantLiberadaReqTipoPrato1);

        //valores esperados após a alteração nas quantidades
        String expQuantExtra = "11,000";
        String expQuantDevolvida = "2,500";
        String expQuantLiberada = "8,500";
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar valor da 'qtde. extra' após a alteração dos valores");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar valor da 'qtde. devolvida' após a alteração dos valores");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificar valor da 'qtde. liberada' após a alteração dos valores");
    }

    public void tentarExcluirUnicoProdReqTipoPrato() {
        tempo();
        click(checkBoxProdutoReqTipoPrato1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Operação Bloqueada. Lançamento deve conter no mínimo um item.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o único produto da requisição de tipo de prato");
        click(botaoOkAlerta);
        click(botaoVoltar);
    }

    public void excluirReTipoPrato() {
        tempo();
        click(checkBoxReqTipoPrato1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão do(s) prato(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir a requisição do tipo de prato");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Deletado com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mesagem exibida no canto da tela após excluir a requisição do tipo de prato");

        mensagem = getText(mensagemNaoHaRegistrosGridTipoPrato);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem apresentada no grid da lista de tipos de prato, informando que não há registros após a exclusão da requisição adicionada");
    }

    public void quantDevolvidaMaiorReqTipoPrato() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarRequisicao);
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoArroz);
        clicarCampoSelecionarValor(campoPrato, pratoArrozTemperado);
        clicarCampoSelecionarValor(campoProduto, produtoOleoAmendoasReqTipoPrato);
        sendKeys(campoQuantExtra, "8");
        click(campoQuantDevolvida);
        clearAndSendKeys(campoQuantDevolvida, "11");
        click(campoHoraLimite);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na após tentar adicionar a quantidade devolvida maior que a extra em um produto da requisição tipo prato");
        click(botaoOkAlerta);
    }

    public void produtoJaCadastradoReqTipoPrato() {
        tempo();
        click(nomeTipoPratoReqTipoPrato1);
        tempo();
        click(botaoAdicionar);
        tempo();
        clicarCampoSelecionarValor(campoProduto, produtoOleoAmedasReqTipoPratoProdJaCad);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Produto já cadastrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de produto já cadastrado em um requisição de tipo de prato");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void calcularReqTipoPrato(String produtos) {
        tempo();
        if (returnIfElementExists(nomeTipoPratoReqTipoPrato1)) excluirTodasReqTipoPrato();

        click(botaoCalcular);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Este processo apagará os produtos inseridos manualmente! Deseja recalcular a requisição?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para cálcular a requisição de tipo de prato");
        click(botaoSim);
        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Calculado com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após cálcular as requisições de tipo de prato");

        //verificar se o cálculo efetuado entrou ao menos 1 requisição de tipo de prato
        if (returnIfElementExists(nomeTipoPratoReqTipoPrato1)) {
            int quantRequisicoes = Integer.parseInt(javaScriptExecutor.executeScript("return document.querySelector(\"#grid-19777484933867646281337 > div.body > div\").childElementCount").toString());
            boolean possuiTipoPrato = quantRequisicoes >= 1;
            Assert.assertTrue(possuiTipoPrato, "Verificar se após o cálcular são apresentandos ao menos 1 tipo de prato");
        } else if (returnIfElementExists(mensagemNaoHaRegistrosGridTipoPrato)) {
            Assert.assertEquals(getText(mensagemNaoHaRegistrosGridTipoPrato), "Erro", "O cálculo efetuado não encontrou nenhuma requisição");
        }

        //verificar as informações do tipo de prato, de acordo com o valor do parâmetro produtos
        switch (produtos) {
            case "Matéria Prima":
                calcTipoPratoMateriaPrima();
                break;
            case "Consumo Fixo":
                calcTipoPratoConsumoFixo();
                break;
            case "Consumo Per Capita":
                calcTipoPratoConsumoPerCapita();
                break;
        }

        click(nomePratoReqTipoPrato1);
        tempo();

        //verificar se na requisição encontrada pelo cálculo, possuí ao menos 1 produto
        if (returnIfElementExists(nomeProdutoReqTipoPrato1)) {
            int quantProdutos = Integer.parseInt(javaScriptExecutor.executeScript("return document.querySelector(\"#grid-19777484932730716086392 > div.body > div\").childElementCount").toString());
            boolean possuiProdutos = quantProdutos >= 1;
            Assert.assertTrue(possuiProdutos, "Verificar se a requisição tem ao menos 1 produtos");
        } else {
            Assert.assertEquals("Prod", "Erro", "O cálculo efetuado não encontrou nunhum produto na requisição");
        }

        click(botaoVoltar);
        tempo();
    }

    private void calcTipoPratoMateriaPrima() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoReqTipoPrato1);
        String encNomeTipoPrato = getText(nomeTipoPratoReqTipoPrato1);
        String encCodigoPrato = getText(codigoPratoReqTipoPrato1);
        String encNomePrato = getText(nomePratoReqTipoPrato1);

        //valores esperados
        String expCodigoTipoPrato = "01";
        String expNomeTipoPrato = "ARROZ";
        String expCodigoPrato = "00.00.00.000";
        String expNomePrato = "ARROZ TEMPEREADO";
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificar 'código do tipo de prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificar 'nome do tipo de prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificar 'código do prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar 'código do prato' encontrado após o cálculo da requisição de tipo de prato");
    }

    private void calcTipoPratoConsumoFixo() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoReqTipoPrato1);
        String encNomeTipoPrato = getText(nomeTipoPratoReqTipoPrato1);
        String encCodigoPrato = getText(codigoPratoReqTipoPrato1);
        String encNomePrato = getText(nomePratoReqTipoPrato1);

        //valores esperados
        String expCodigoTipoPrato = "04";
        String expNomeTipoPrato = "PRATO PRINCIPAL";
        String expCodigoPrato = "00.00.00.001";
        String expNomePrato = "FEIJOADA SIMPLES";
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificar 'código do tipo de prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificar 'nome do tipo de prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificar 'código do prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar 'código do prato' encontrado após o cálculo da requisição de tipo de prato");
    }

    private void calcTipoPratoConsumoPerCapita() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoReqTipoPrato1);
        String encNomeTipoPrato = getText(nomeTipoPratoReqTipoPrato1);
        String encCodigoPrato = getText(codigoPratoReqTipoPrato1);
        String encNomePrato = getText(nomePratoReqTipoPrato1);

        //valores esperados
        String expCodigoTipoPrato = "02";
        String expNomeTipoPrato = "GUARNIÇÃO";
        String expCodigoPrato = "00.00.00.004";
        String expNomePrato = "FEIJAO";
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificar 'código do tipo de prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificar 'nome do tipo de prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificar 'código do prato' encontrado após o cálculo da requisição de tipo de prato");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar 'código do prato' encontrado após o cálculo da requisição de tipo de prato");
    }

    public void excluirTodasReqTipoPrato() {
        tempo();
        click(checkBoxTodasReqTipoPrato);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão do(s) prato(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após selecionar todas as requisições de tipo de prato e clicar em excluir");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Deletado com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após deletar todas as requisições de tipo de prato");
        tempo();
        tempo();

        mensagem = getText(mensagemNaoHaRegistrosGridTipoPrato);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem no grid da lista de requisições de tipo de prato, após a exclusão de todas as requisições");
    }

    //////////
    public void addReqProduto() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarRequisicao);
        clicarCampoSelecionarValor(campoProduto, produtoCreosotoReqProduto);
        sendKeys(campoQuantExtra, "7");
        click(campoQuantDevolvida);
        clearAndSendKeys(campoQuantDevolvida, "2");
        click(campoHoraLimite);
        sendKeys(campoHoraLimite, "09:20");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela após adicionar uma requisição para um produto");
    }

    public void addSegundaReqProd() {
        tempo();
        click(botaoAdicionarRequisicao);
        clicarCampoSelecionarValor(campoProduto, produtoQuerosenaReqProduto);
        sendKeys(campoQuantExtra, "10");
        click(campoQuantDevolvida);
        clearAndSendKeys(campoQuantDevolvida, "3");
        click(campoHoraLimite);
        sendKeys(campoHoraLimite, "11:00");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela após adicionar uma requisição para um produto");
    }

    public void verificarSegundoProdutoReqProd() {
        //valores encontrados
        String encCodigoProduto = getText(codigoProdutoReqProd2);
        String encProduto = getText(nomeProdutoReqProd2);
        String encUnidade = getText(unidadeProdutoReqProd2);
        String encQuantPrev = getText(quantPrevistaReqProd2);
        String encQuantExtra = getText(quantExtraReqProd2);
        String encQuantDevolvida = getText(quantDevolvidaReqProd2);
        String encQuantLiberada = getText(quantLiberadaReqProd2);

        //valores esperados
        String expCodigoProduto = "1.01.1.1.01.004.00";
        String expProduto = "QUEROSENE";
        String expUnidade = "L";
        String expQuantPrev = "0,000";
        String expQuantExtra = "10,000";
        String expQuantDevolvida = "3,000";
        String expQuantLiberada = "7,000";
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código' do segundo produto adicionado em uma requisição de produto");
        Assert.assertEquals(encProduto, expProduto, "Verificar 'nome' do segundo produto adicionado em uma requisição de produto");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do segundo produto adicionado em uma requisição de produto");
        Assert.assertEquals(encQuantPrev, expQuantPrev, "Verificar 'qtde. prevista' do segundo produto adicionado em uma requisição de produto");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qtde. extra' do segundo produto adicionado em uma requisição de produto");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qtde. devolvida' do segundo produto adicionado em uma requisição de produto");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificar 'qtde. liberada' do segundo produto adicionado em uma requisição de produto");
    }

    public void verificarRedProdutoAdd() {
        //valores encontrados
        String encCodigoProduto = getText(codigoProdutoReqProd1);
        String encNomeproduto = getText(nomeProdutoReqProd1);
        String encUnidade = getText(unidadeProdutoReqProd1);
        String encQuantPrev = getText(quantPrevistaReqProd1);
        String encQuantExtra = getText(quantExtraReqProd1);
        String encQuantDevolvida = getText(quantDevolvidaReqProd1);
        String encQuantLiberada = getText(quantLiberadaReqProd1);
//        String encDataLimite = getText(dataLimiteReqProd1);

        //valores esperados
        String expCodigoProduto = "1.01.1.1.01.001.00";
        String expNomeProduto = "CREOSOTO";
        String expUnidade = "L";
        String expQuantPrev = "0,000";
        String expQuantExtra = "7,000";
        String expQuantDevolvida = "2,000";
        String expQuantLiberada = "5,000";
//        String expDataLimite = "15/09/2023";
        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código' do produto adicionado na requisição produto");
        Assert.assertEquals(encNomeproduto, expNomeProduto, "Verificar 'nome' do produto adicionado na requisição produto");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do produto adicionado na requisição produto");
        Assert.assertEquals(encQuantPrev, expQuantPrev, "Verificar 'quantidade prevista' do produto adicionado na requisição produto");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'quantidade extra' do produto adicionado na requisição produto");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'quantidade devolvida' do produto adicionado na requisição produto");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificar 'quantidade liberada' do produto adicionado na requisição produto");
//        Assert.assertEquals(encDataLimite, expDataLimite, "Verificar 'data limite' do produto adicionado na requisição produto");
    }

    public void excluirSeguntoProdutoReqProd() {
        tempo();
        click(checkBoxProdutoReqProd2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão do(s) produto(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o segundo produto da requisição de produto");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso após a exclusão do produto na requisição de produto");

        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1977748493450785601527 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "1", "Verificar quando de produto na requisição");
    }

    public void alterarValoresProdutoReqProd() {
        alterarValorDoCampo(quantExtraReqProd1, "9");
        alterarValorDoCampo(quantDevolvidaReqProd1, "4");
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após alterar as quantidade do produto na requisição");

        //valores encontrados após as alterações
        String encQuantExtra = getText(quantExtraReqProd1);
        String encQuantDevolvida = getText(quantDevolvidaReqProd1);
        String encQuantLiberada = getText(quantLiberadaReqProd1);

        //valores esperados após as alterações
        String expQuantExtra = "9,000";
        String expQuantDevolvida = "4,000";
        String expQuantLiberada = "5,000";
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar valor da 'qtde. extra' após a alterações da quantidade do produto na requisição de produto");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar valor da 'qtde. devolvida' após a alterações da quantidade do produto na requisição de produto");
        Assert.assertEquals(encQuantLiberada, expQuantLiberada, "Verificar valor da 'qtde. liberada' após a alterações da quantidade do produto na requisição de produto");
    }

    public void excluirReqProduto() {
        tempo();
        click(checkBoxProdutoReqProd1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão do(s) produto(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir a requisição do produto");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem excluído com sucesso exibida na tela após excluir a requisição do produto");

        mensagem = getText(mensagemNaoHaRegistrosGridProdutos);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem apresentada no grid da lista de produtos, informando que não há registros após a exclusão da requisição adicionada");
    }

    public void quantDevolvidaMaiorReqProd() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarRequisicao);
        clicarCampoSelecionarValor(campoProduto, produtoQuerosenaReqProduto);
        sendKeys(campoQuantExtra, "3");
        click(campoQuantDevolvida);
        clearAndSendKeys(campoQuantDevolvida, "8");
        click(campoHoraLimite);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na após tentar adicionar a quantidade devolvida maior que a extra em um produto da requisição produto");
        click(botaoOkAlerta);
    }

    public void produtoJaCadastradoReqProduto() {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoProduto, produtoCreosotoReqProduto);

        String mensagem = "Produto já cadastrado";
        String mensagemEsperada = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um produto já cadastrado na requisição de produto");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
    }

    public void calculoRequisicaoProduto() {
        tempo();
        if (returnIfElementExists(nomeProdutoReqProd1)) excluirTodasReqProduto();

        click(botaoCalcular);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Este processo apagará os produtos inseridos manualmente! Deseja recalcular a requisição?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para cálcular a requisição de tipo de prato");
        click(botaoSim);
        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Calculado com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após cálcular as requisições de tipo de prato");

        //verificar se o cálculo efetuado entrou ao menos 1 produto na requisição de produto
        if (returnIfElementExists(nomeProdutoReqProd1)) {
            int quantRequisicoes = Integer.parseInt(javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1977748493450785601527 > div.body > div\").childElementCount").toString());
            boolean possuiTipoPrato = quantRequisicoes >= 1;
            Assert.assertTrue(possuiTipoPrato, "Verificar se após o cálcular é apresentando ao menos 1 produto");
        } else if (returnIfElementExists(mensagemNaoHaRegistrosGridProdutos)) {
            Assert.assertEquals(getText(mensagemNaoHaRegistrosGridProdutos), "Erro", "O cálculo efetuado não encontrou nenhuma requisição de produto");
        }
    }

    public void excluirTodasReqProduto() {
        tempo();
        click(checkBoxTodasReqProduto);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Confirma exclusão do(s) produto(s) selecionado(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após selecionar todas as requisições de tipo de prato e clicar em excluir");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após deletar todas as requisições de tipo de prato");
        tempo();
        tempo();

        mensagem = getText(mensagemNaoHaRegistrosGridProdutos);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem no grid da lista de requisições de tipo de prato, após a exclusão de todas as requisições");
    }

    //////////
    public void camposObrigatoriosFiltroIni() {
        tempo();
        click(botaoCampoUnidadeFiltroIni);
        click(botaoCampoDataFiltroIni);
        click(botaoAplicarFiltro);
        String mensagemEsperada = "Campo obrigatório";
        String unidade = getText(mensagemObrigatorioUnidadeFiltroIni);
        String servico = getText(mensagemObrigatorioServicoFiltroIni);
        String data = getText(mensagemObrigatorioDataFiltroIni);

        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade' no filtro inicial");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'serviço' no filtro inicial");
        Assert.assertEquals(data, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'data' no filtro inicial");
    }

    public void camposObrigatoriosFormTipoPrato() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarRequisicao);
        tempo();
        click(botaoCampoDataLimiteFormAddReqTipoPrato);
        tempo();
        click(botaoSalvar);

        String mensagemEsperada = "Campo obrigatório";
        String tipoPrato = getText(mensagemObrigatorioTipoPratoFormTipoPrato);
        String prato = getText(mensagemObrigatorioPratoFormTipoPrato);
        String produto = getText(mensagemObrigatorioProdutoFormTipoPrato);
        String dataLimite = getText(mensagemObrigatorioDataLimiteFormTipoPrato);
        String horaLimite = getText(mensagemObrigatorioHoraLimiteFormTipoPrato);
        Assert.assertEquals(tipoPrato, mensagemEsperada, "Verificar mensagem campo obrigatório no campo 'tipo de prato' no formulário para adicionar uma requisição de tipo de prato");
        Assert.assertEquals(prato, mensagemEsperada, "Verificar mensagem campo obrigatório no campo 'prato' no formulário para adicionar uma requisição de tipo de prato");
        Assert.assertEquals(produto, mensagemEsperada, "Verificar mensagem campo obrigatório no campo 'produto' no formulário para adicionar uma requisição de tipo de prato");
        Assert.assertEquals(dataLimite, mensagemEsperada, "Verificar mensagem campo obrigatório no campo 'data limite' no formulário para adicionar uma requisição de tipo de prato");
        Assert.assertEquals(horaLimite, mensagemEsperada, "Verificar mensagem campo obrigatório no campo 'hora limite' no formulário para adicionar uma requisição de tipo de prato");
    }

    public void camposObrigatoriosFormProduto() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarRequisicao);
        tempo();
        click(botaoCampoDataLimiteFormAddReqProduto);
        tempo();
        click(botaoSalvar);

        String mensagemEsperada = "Campo obrigatório";
        String produto = getText(mensagemObrigatorioProdutoFormProduto);
        String dataLimite = getText(mensagemObrigatorioDataLimiteFormProduto);
        String horaLimite = getText(mensagemObrigatorioHoraLimiteFormProduto);
        Assert.assertEquals(produto, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'produto' do formulário para adicionar uma requisição de produto");
        Assert.assertEquals(dataLimite, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'data limite' do formulário para adicionar uma requisição de produto");
        Assert.assertEquals(horaLimite, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'hora limite' do formulário para adicionar uma requisição de produto");
    }


    public void inserirMensagem() {
        tempo();
        tempo();
        tempo();
        click(abaMensagem);
        clearAndSendKeys(campoMensagem, "Mensagem automatizada");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto da tela após adicionar uma mensagem à requisição");

        mensagem = javaScriptExecutor.executeScript("return document.querySelector(\"#DSOBSREQU\").value").toString();
        mensagemEsperada = "Mensagem automatizada";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar se a mensagem adicionada foi salva corretamente");
    }

    public void editarMensagem() {
        tempo();
        tempo();
        clearAndSendKeys(campoMensagem, "Editar mensagem auto");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar uma mensagem");

        mensagem = javaScriptExecutor.executeScript("return document.querySelector(\"#DSOBSREQU\").value").toString();
        mensagemEsperada = "Editar mensagem auto";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar se a mensagem adicionada foi salva corretamente");
    }

    public void apagarMensagem() {
        tempo();
        tempo();
        clearAndSendKeys(campoMensagem, "");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar uma mensagem");

        mensagem = javaScriptExecutor.executeScript("return document.querySelector(\"#DSOBSREQU\").value").toString();
        mensagemEsperada = "";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar se a mensagem adicionada foi salva corretamente");
    }


    public void verificarOpcoesProdutos() {
        List<String> produtos = new ArrayList<>();
        produtos.add("Matéria Prima");
        produtos.add("Consumo Fixo");
        produtos.add("Consumo Per Capita");

        click(campoProdutosFiltroIni);

        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#popup > span > section > section > section > div > form > section > div > div:nth-child(3) > div:nth-child(1) > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\\\{\\\\{field\\\\.align.\\\\|\\\\|.\\\\'left\\\\'\\\\}\\\\}.ng-pristine.ng-untouched.ng-valid > ul\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "3", "Verificar quantidade de opções no campo produtos no filtro inicial");

        for (int x = 0; x <= 2; x++) {
            By opProduto = By.xpath("//div[@data-zh-id=\"1977748493180397912489\"]//ul[@class=\"list zh-new-select-list\"]//li[@data-value=\"" + x + "\"]");
            Assert.assertEquals(getText(opProduto), produtos.get(x), "Verificar opção " + (x+1) + " da lista de produtos no filtro inicial");
        }
    }



    ///////////
    public void acessarTelaRelatorio() {
        preencherFiltroInicial("Tipo de Prato", "Matéria Prima");
        tempo();
        tempo();
        click(botaoAcessarTelaRelatorio);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
        switch (nomeRelatorio) {
            case "Requisição por Serviço":
                clicarCampoSelecionarValor(campoRelatorio, relatorioRequisicaoServico);
                break;
            case "Requisição por Serviço (Turnos)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioTurnos);
                break;
            case "Requisição por Operador":
                clicarCampoSelecionarValor(campoRelatorio, relatorioRequisicaoOperador);
                break;
            case "Requisição por Serviço/Ponto de Entrega (Analítico)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioServicoPontoEntrega);
                break;
            case "Requisição por Grupo de Serviço (Sintético)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoServicoSintetico);
                break;
            case "Requisição por Serviço (Tipo de Prato/Prato)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioTipoPrato);
                break;
            case "Requisição por Serviço (Unidade Adicional)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioUnidadeAdicional);
                break;
        }
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicialRel, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarUnidade() {
        clicarCampoSelecionarValor(campoUnidadeRel, unidadeDepositoBC129telaRel);
    }

    public void selecionarGrupoServicos() {
        click(checkBoxTodosGrupoServico);
        click(campoGrupoServicoRel);
        click(grupoServicoGeral);
        click(grupoServicoPreparos);
        click(grupoServicoTransp);
        click(botaoOk);
    }

    public void selecionarServico() {
        click(checkBoxTodosServico);
        click(campoServicoRel);
        click(servicoJantaRel);
        click(servicoRefeicoesTranportadasRel);
        click(botaoOk);
    }

    public void selecionarTipoDeConsumo() {
        click(checkBoxTodosTiposDeConsumo);
        click(campoTiposDeConsumoRel);
        click(tipoConsumoMateriaPrimaRel);
        click(botaoOk);
    }

    public void selecionarPontoDeEntrega() {
        click(checkBoxTodosPontoEntrega);
        click(campoPontoEntregaRel);
        click(pontoDeEntregaRestauranteNormas);
        click(botaoOk);
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    public void camposHabilitadosTelaRelatorios() {
        tempo();
        tempo();
        List<String> listRelatorios = relatorios();

        for (String rel : listRelatorios) {
            tempo();
            selecionarRelatorio(rel);
            tempo();


            boolean todosGruposServico = returnIfElementIsSelected(inputCheckBoxGrupoServico);
            boolean todosServico = returnIfElementIsSelected(inputCheckBoxServico);
            boolean todosPontoEntrega = returnIfElementIsEnabled(inputCheckBoxPontoEntrega);
            boolean calcularAntesImprimir = returnIfElementIsEnabled(inputCheckBoxCalcularAntesDeImprimir);
            boolean imprimirCardapio = returnIfElementIsSelected(inputCheckBoxImprimirCardapio);
            boolean arredondarQuantProd = returnIfElementIsSelected(inputCheckBoxArredondarQuantProdutos);
            boolean quebraPagina = returnIfElementIsEnabled(inputCheckBoxQuebraPagina);
            boolean imprimirLinhasBranco = returnIfElementIsSelected(inputCheckBoxImprimirLinhasBranco);
            boolean tiposDeConsumo = returnIfElementIsSelected(inputCheckBoxTiposConsumo);

            Assert.assertTrue(todosGruposServico, "Verificar se por padrão o check-box todos do campo 'grupo de serviços', já está selecionado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(todosServico, "Verificar se por padrão o check-box todos do campo 'serviço', já está selecionado com o seguinte relatório selecionado: " + rel);
            Assert.assertFalse(imprimirCardapio, "Verificar se por padrão o check-box 'imprimir cardápio', não está selecionado com o seguinte relatório selecionado: " + rel);
            Assert.assertFalse(arredondarQuantProd, "Verificar se por padrão o check-box 'arredondar qtde. dos produtos', não está selecionado com o seguinte relatório selecionado: " + rel);
            Assert.assertFalse(imprimirLinhasBranco, "Verificar se por padrão o check-box 'imprimir linhas em branco', não está selecionado com o seguinte relatório selecionado: " + rel);
            Assert.assertTrue(tiposDeConsumo, "Verificar se por padrão o check-box todos do campo 'tipos de consumo (calcular/imprimir)', já está selecionado com o seguinte relatório selecionado: " + rel);

            if (!rel.equals("Requisição por Serviço/Ponto de Entrega (Analítico)")) {
                Assert.assertFalse(todosPontoEntrega, "Verificar se por padrão o check-box todos do campo 'ponto de entrega', está desbilitado com o seguinte relatório selecionado: " + rel);
                Assert.assertTrue(calcularAntesImprimir, "Verificar se por padrão o check-box 'calcular antes de imprimir', está habilitado com o seguinte relatório selecionado: " + rel);
                Assert.assertTrue(quebraPagina, "Verificar se por padrão o check-box  'quebra de página', está habilitado com o seguinte relatório selecionado: " + rel);

                calcularAntesImprimir = returnIfElementIsSelected(inputCheckBoxCalcularAntesDeImprimir);
                quebraPagina = returnIfElementIsSelected(inputCheckBoxQuebraPagina);
                Assert.assertFalse(calcularAntesImprimir, "Verificar se por padrão o check-box 'calcular antes de imprimir' não está selecionado com o seguinte relatóro selecionado: " + rel);
                Assert.assertTrue(quebraPagina, "Verificar se por padrão o check-box 'quebra de página' já está selecionado com o seguinte relatóro selecionado: " + rel);
            } else {
                Assert.assertTrue(todosPontoEntrega, "Verificar se por padrão o check-box todos do campo 'ponto de entrega', está habilitado com o seguinte relatório selecionado: " + rel);
                Assert.assertFalse(calcularAntesImprimir, "Verificar se por padrão o check-box 'calcular antes de imprimir', está desabilitado com o seguinte relatório selecionado: " + rel);
                Assert.assertFalse(quebraPagina, "Verificar se por padrão o check-box  'quebra de página', está desabilitado com o seguinte relatório selecionado: " + rel);
            }

            tempo();
        }

    }

    private List<String> relatorios() {
        List<String> relatorios = new ArrayList<>();
        relatorios.add("Requisição por Serviço");
        relatorios.add("Requisição por Serviço (Turnos)");
        relatorios.add("Requisição por Operador");
        relatorios.add("Requisição por Serviço/Ponto de Entrega (Analítico)");
        relatorios.add("Requisição por Grupo de Serviço (Sintético)");
        relatorios.add("Requisição por Serviço (Tipo de Prato/Prato)");
        relatorios.add("Requisição por Serviço (Unidade Adicional)");
        return relatorios;
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    private void alterarValorDoCampo(By campo, String valor) {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campo)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }


}