package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.AlergenicoProdutoFlows;
import com.javaseleniumtemplate.pages.AlergenicoProdutoPage;
import org.testng.annotations.Test;

public class AlergenicoProdutoTests extends TestBase {

    AlergenicoProdutoPage alergenicoProdutoPage;
    AlergenicoProdutoFlows alergenicoProdutoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Alergênicos do Produto'
    //adicionar alergênicos ao produto 'CINERARIA MARITIMA  PLANTA INTEIRA'
    //adicionar mais um alergênico ao produto
    //realizar a verificação dos alergênicos adicionados
    //adicionar um terceiro alergênico ao produtos, verificar os 3 alergênicos(nome e sigla) adicionados
    //excluir apenas um alergênico
    //excluir todos os alergênicos e verificar a mensagem de não há registo, no campo onde são apresentados os alergênicos do produto
    @Test
    public void alergenicoProd() {
        alergenicoProdutoPage = new AlergenicoProdutoPage();
        alergenicoProdutoFlows = new AlergenicoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoProdutoFlows.navegateTelaAlergenicosProduto();
        alergenicoProdutoPage.selecionarProduto();
        alergenicoProdutoPage.addAlergenicos();
        alergenicoProdutoPage.verificarAlergenicosAdd();
        alergenicoProdutoPage.adicionarCrustaceo();
        alergenicoProdutoPage.excluirAlergenico();
        alergenicoProdutoPage.excluirTodosAlergenicos();
    }


    //acessar a tela 'Alergênicos do Produto'
    //cadastro automático dos alergênicos amendoim e moluscos, nos produtos CARBONATO DE MAGNESIO e CARBONATO DE MAGNESIO 500G
    //verificação dos alergênicos adicionados nos produtos
    //exclusão dos alergênicos por produto do cadastro automático
    @Test
    public void cadastroAutomatico() {
        alergenicoProdutoPage = new AlergenicoProdutoPage();
        alergenicoProdutoFlows = new AlergenicoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoProdutoFlows.navegateTelaAlergenicosProduto();
        alergenicoProdutoPage.preencherFormCadAutomaticoInclusao();
        alergenicoProdutoPage.verificarCadAutomatico();
        alergenicoProdutoPage.preencherFormCadAutomatidoExcluir();
        alergenicoProdutoPage.verificarExclusaoAutomatica();
        alergenicoProdutoPage.camposObrigatorioCadAuto();
    }


    //acessar a tela 'Alergênicos do Produto'
    //clicar no botão 'Cadastro Automático', clicar em confirmar e verificar os campos obrigatórios
    @Test
    public void campoObrigatorios() {
        alergenicoProdutoPage = new AlergenicoProdutoPage();
        alergenicoProdutoFlows = new AlergenicoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        alergenicoProdutoFlows.navegateTelaAlergenicosProduto();
        alergenicoProdutoPage.camposObrigatorioCadAuto();
    }

}