package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.ApresentacaoProdutoFlows;
import com.javaseleniumtemplate.pages.ApresentacaoProdutoPage;
import org.testng.annotations.Test;

public class ApresentacaoProdutoTests extends TestBase {

    ApresentacaoProdutoPage apresentacaoProdutoPage;
    ApresentacaoProdutoFlows apresentacaoProdutoFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Apresentação do Produto'
    //clicar no botão relatório, verificar se o relatório Apresentação do Produto já está selecionado quando abre a tela
    //clicar no botão 'gerar relatório', clicar no tipo pdf, clicar em confirmar
    //conferir se a url do relatório está correta e fechar a guia do relatório
    @Test
    public void gerarRel() {
        apresentacaoProdutoPage = new ApresentacaoProdutoPage();
        apresentacaoProdutoFlows = new ApresentacaoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        apresentacaoProdutoFlows.navegateApresentacaoProduto();
        apresentacaoProdutoPage.gerarRelatorio();
    }


    //acessar a tela 'Apresentação do Produto'
    //clicar no botão relatório
    //clicar no botão do campo relatório, para que o campo fique vazio
    //clicar no botão gerar relatório
    //verificar a mensagem de campo obrigatório, no campo relatório
    //atualizar a página, pesquisar pelo produto CLORETO DE POTASSIO e selecionar o mesmo
    //clicar em adicionar e em salvar e verificar a mensagem de que a quantidade deve ser maior que 0. Obs: neste caso a quantidade estará vazia
    //clicar no botão ok, preencher a quantidade com o valor 0, clicar em salvar e verificar a mensagem informando que o valor deve ser maior que 0
    //clicar em ok, inserir o valor 7 na quantidade, clicar em salvar e verificar a mensagem de campo obrigatório no campo 'apresentação'
    //selecionar a apresentação "Gotas", clicar em salvar
    //clicar no check-box da apresentação adicionar e excluir a mesma
    //atualizar a página, pesquisar pelo produto CANFORA KG e selecionar o mesmo
    //alterar o valor da quantidade para 0, clicar em salvar e verificar a mensagem informando que a quantidade deve ser maior que 0
    //inserir o valor 6, salvar as alterações
    //alterar o valor da quantidade para 9. Valor este que estava na quantidade no início da edição
    @Test
    public void camposObrigatorios() {
        apresentacaoProdutoPage = new ApresentacaoProdutoPage();
        apresentacaoProdutoFlows = new ApresentacaoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        apresentacaoProdutoFlows.navegateApresentacaoProduto();
        apresentacaoProdutoPage.campoObrigatorioRelatorio();
        apresentacaoProdutoPage.refresh();
        apresentacaoProdutoPage.camposObrigatoriosAddApresentacao();
        apresentacaoProdutoPage.excluirApresentacao();
        apresentacaoProdutoPage.refresh();
        apresentacaoProdutoPage.valorObrigatorioEdicaoQuant();
    }


    //acessar a tela 'Apresentação do Produto'
    //pesquisar pelo produto 'CREOSOTO EMBALAGEM DE 1L' e acessar o mesmo
    //alterar o valor da quantidade para 3,8000, clicar em salvar alterações, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se o novo valor foi salvo corretamente
    //alterar o valor da quantidade para o valor que estava no início do teste 7,50000
    @Test
    public void editarQuantidade() {
        apresentacaoProdutoPage = new ApresentacaoProdutoPage();
        apresentacaoProdutoFlows = new ApresentacaoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        apresentacaoProdutoFlows.navegateApresentacaoProduto();
        apresentacaoProdutoPage.editarQuantidade();
    }


    //acessar a tela 'Apresentação do Produto'
    //pesquisar pelo produto CHINA OFFICINALLIS (CASCA) e selecionar o mesmo
    //adicionar uma verificação ao produto e verificar se os valores (código, apresentação, quantidade e unidade) foram salvos corretamente
    //clicar no check-box da apresentação adicionada, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarExcluirProduto() {
        apresentacaoProdutoPage = new ApresentacaoProdutoPage();
        apresentacaoProdutoFlows = new ApresentacaoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        apresentacaoProdutoFlows.navegateApresentacaoProduto();
        apresentacaoProdutoPage.adicionarApresentacao();
        apresentacaoProdutoPage.excluirApresentacao();
    }

}
