package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AtualizarDataReferenciaCustosFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class AtualizarDataReferenciaCustosTests extends TestBase {

    LoginFlows loginFlows;
    AtualizarDataReferenciaCustosFlows atualizarDataReferenciaCustosFlows;

    public void acessarTela(){
        loginFlows = new LoginFlows();
        atualizarDataReferenciaCustosFlows = new AtualizarDataReferenciaCustosFlows();
        loginFlows.efetuarLogin();
        atualizarDataReferenciaCustosFlows.acessarTelaAtualizaDataReferencia();
    }

    @Test
    public void atualizaCustoDataAnteriorProc(){
        String CDFILIAL = "0003";
        acessarTela();
        atualizarDataReferenciaCustosFlows.atualizaCustoDataAnteriorProc(CDFILIAL);
    }

    @Test
    public void atualizarReferenciaCustoUnidade(){
        String CDFILIAL = "0002";
        String CDSERVFILI = "00002";
        acessarTela();
        atualizarDataReferenciaCustosFlows.atualizarCustoReferenciaUnidade(CDFILIAL,CDSERVFILI);
    }

    @Test
    public void atualizarCustoReferenciaTodos(){
        acessarTela();
        atualizarDataReferenciaCustosFlows.atualizarCustoReferenciaTodos();
    }

    @Test
    public void atualizarCustoReferenciaAgrupamento(){
        acessarTela();
        atualizarDataReferenciaCustosFlows.atualizarCustoReferenciaAgrupamento();
    }

    @Test
    public void validaCamposObrigatorios(){
        String msgEsperada = "Campo obrigatório";
        acessarTela();
        atualizarDataReferenciaCustosFlows.validarCamposObrigatorios();
        Assert.assertEquals(atualizarDataReferenciaCustosFlows.msgEncontradaUnidade(),msgEsperada,"Campo Unidade: ");
        Assert.assertEquals(atualizarDataReferenciaCustosFlows.msgEncontradaServico(),msgEsperada,"Campo Servico: ");
        Assert.assertEquals(atualizarDataReferenciaCustosFlows.msgEncontradaMes(),msgEsperada,"Campo Mês: ");
        Assert.assertEquals(atualizarDataReferenciaCustosFlows.msgEncontradaCusto(),msgEsperada,"Campo Tipo de Custo: ");
        Assert.assertEquals(atualizarDataReferenciaCustosFlows.msgEncontradaDtRef(),msgEsperada,"Campo Data de Referência");
    }



}
