package com.javaseleniumtemplate.tests;
import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.GrupoTipodePratoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.GrupoTipodePratoFlows;
import com.javaseleniumtemplate.pages.GrupoTipodePratoPage;

import org.testng.Assert;
import org.testng.annotations.Test;
public class CadastroGrupoTipodePratoTests extends TestBase {

    LoginFlows loginFlows;
    GrupoTipodePratoFlows grupoTipodePratoFlows;


    @Test
    public void cadastroGrupoTipoPrato() {
        loginFlows = new LoginFlows();
        grupoTipodePratoFlows = new GrupoTipodePratoFlows();
        String CDGRUPO = "20";
        String NMGRUPO = "GUARNIÇÃO";
        String CDGRUP = "30";
        String NMGRUP = "SALADA";
        String MSESPERADA = "GUARNIÇÃO";
        String MSGESPERADA = "SALADA";

        loginFlows.efetuarLogin();
        grupoTipodePratoFlows.navegarParaGrupoTipodePrato();
        grupoTipodePratoFlows.validarCamposObrigatorios(CDGRUPO,NMGRUPO);
        grupoTipodePratoFlows.insereGrupo(CDGRUPO,NMGRUPO);
        grupoTipodePratoFlows.insereGrupo(CDGRUP,NMGRUP);
        grupoTipodePratoFlows.validaInsercaoRegistroIgual(CDGRUP,NMGRUP);
        Assert.assertEquals(grupoTipodePratoFlows.retornaCadastroGrupo(),MSESPERADA,"Falha ao salvar informação: ");
        Assert.assertEquals(grupoTipodePratoFlows.retornaCadastroGrupo2(),MSGESPERADA,"Falha ao salvar informação: ");

    }

    @Test
    public void editarRegistro(){
        loginFlows = new LoginFlows();
        grupoTipodePratoFlows = new GrupoTipodePratoFlows();

        String NMGRUPO01 = "SALADA";
        String NMGRUPO02 = "DESJEJUM";
        String MSGESPERADA01 = "SALADA";
        String MSGESPERADA02 = "DESJEJUM";

        loginFlows.efetuarLogin();
        grupoTipodePratoFlows.navegarParaGrupoTipodePrato();
        grupoTipodePratoFlows.salvarRegistroSemNome();
        grupoTipodePratoFlows.editarESalvarRegistro(NMGRUPO01,NMGRUPO02);
        Assert.assertEquals(grupoTipodePratoFlows.mensagemEncontrada01(),MSGESPERADA01,"Falha ao editar o grupo: ");
        Assert.assertEquals(grupoTipodePratoFlows.mensagemEncontrada02(),MSGESPERADA02,"Falha ao editar o grupo: ");

    }

    @Test
    public void excluirRegistros(){
        loginFlows = new LoginFlows();
        grupoTipodePratoFlows = new GrupoTipodePratoFlows();
        String MSGESPERADA = "Excluído com sucesso.";

        loginFlows.efetuarLogin();
        grupoTipodePratoFlows.navegarParaGrupoTipodePrato();
        grupoTipodePratoFlows.apagaRegistroRelacionado();
        grupoTipodePratoFlows.apagarRegistroGuarnicao();
        Assert.assertEquals(grupoTipodePratoFlows.validarExclusao(),MSGESPERADA,"Registro não apagado: ");
        grupoTipodePratoFlows.apagarRegistroSalada();
        Assert.assertEquals(grupoTipodePratoFlows.validarExclusao(),MSGESPERADA,"Registro não apagado: ");
    }



}
