package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.HistoricoRequisicaoFlows;
import com.javaseleniumtemplate.pages.HistoricoRequisicaoPage;
import org.testng.annotations.Test;

public class  HistoricoRequisicaoTests extends TestBase {

    HistoricoRequisicaoPage historicoRequisicaoPage;
    HistoricoRequisicaoFlows historicoRequisicaoFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAnaliticoData() {
        emitiRelatorio("Histórico de Requisição (Analítico por Data)");
    }

    @Test
    public void relatorioSinteticoData() {
        emitiRelatorio("Histórico de Requisição (Sintético por Data)");
    }

    @Test
    public void relatorioSinteticoOperador() {
        emitiRelatorio("Histórico de Requisição (Sintético por Operador)");
    }

    @Test
    public void relatorioAnaliticoOperador() {
        emitiRelatorio("Histórico de Requisição (Analítico por Operador)");
    }


    //acessar a tela 'Histórico de Requisição'
    //selecionar o relatório que foi passada como parâmetros
    //selecionar a unidade Jabaquara
    //preencher as datas inicial e final
    //gerar o relatório, com as opções de operador e serviço, com o campo "todos" marcado
    //fechar a guia do relatório
    //selecionar alguns operadores e serviços
    //gerar novamente o relatório
    //fechar a guia com o relatório
    public void emitiRelatorio(String relatorio) {
        historicoRequisicaoPage = new HistoricoRequisicaoPage();
        historicoRequisicaoFlows = new HistoricoRequisicaoFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/02/2023";
        String dataFinal = "30/04/2023";

        loginFlows.efetuarLogin();
        historicoRequisicaoFlows.navegateHistoricoRequisicao();
        historicoRequisicaoPage.selecionaRelatorio(relatorio);
        historicoRequisicaoPage.selecionarUnidadeJabaquara();
        historicoRequisicaoPage.preencherDatas(dataInicial, dataFinal);
        historicoRequisicaoPage.geraRelatorio();
        historicoRequisicaoPage.selecionarAlgunsOperadores();
        historicoRequisicaoPage.selecionarServicos();
        historicoRequisicaoPage.geraRelatorio();
    }


    //acessar a tela 'Histórico de Requisição'
    //selecionar o relatório 'Histórico de Requisição (Analítico por Data)', deixar o campos (unidade, operador e serviço) vazios, clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: unidade, data, operador e serviço
    //atualizar a tela, selecionar o relatório 'Histórico de Requisição (Sintético por Data)', deixar o campos (unidade, operador e serviço) vazios, clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: unidade, data, operador e serviço
    //atualizar a tela, selecionar o relatório 'Histórico de Requisição (Sintético por Operador)', deixar o campos (unidade, operador e serviço) vazios, clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: unidade, data, operador e serviço
    //atualizar a tela, selecionar o relatório 'Histórico de Requisição (Analítico por Operador)', deixar o campos (unidade, operador e serviço) vazios, clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: unidade, data, operador e serviço
    @Test
    public void camposObrigatorioPorRelatorio() {
        historicoRequisicaoPage = new HistoricoRequisicaoPage();
        historicoRequisicaoFlows = new HistoricoRequisicaoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        historicoRequisicaoFlows.navegateHistoricoRequisicao();
        historicoRequisicaoPage.selecionaRelatorio("Histórico de Requisição (Analítico por Data)");
        historicoRequisicaoPage.camposObrigatorios();
        historicoRequisicaoPage.refresh();
        historicoRequisicaoPage.selecionaRelatorio("Histórico de Requisição (Sintético por Data)");
        historicoRequisicaoPage.camposObrigatorios();
        historicoRequisicaoPage.refresh();
        historicoRequisicaoPage.selecionaRelatorio("Histórico de Requisição (Sintético por Operador)");
        historicoRequisicaoPage.camposObrigatorios();
        historicoRequisicaoPage.refresh();
        historicoRequisicaoPage.selecionaRelatorio("Histórico de Requisição (Analítico por Operador)");
        historicoRequisicaoPage.camposObrigatorios();
    }


}
