package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MedicaoEfetivosFlows;

import org.testng.Assert;
import org.testng.annotations.Test;


public class  MedicaoEfetivosTests extends TestBase {

    LoginFlows loginFlows;
    MedicaoEfetivosFlows efetivosFlows;


    @Test
    public void informaEfetivos() {
        loginFlows = new LoginFlows();
        efetivosFlows = new MedicaoEfetivosFlows();
        String UNIDADE = "0002";
        String DTEFETIVOS = "19/10/2023";
        //Efetivos Planejamento
        String QTDCLIENTE = "10";
        String QTDFUNCIONARIO = "2";
        String QTDDOACAO = "1";
        String TOTEFET = "13,000";
        String QTDESPERADACLIENTE = "10,00000";
        String QTDESPERADAFUNCIONARIO = "2,00000";
        String QTDESPERADADOACAO = "1,00000";
        String QTDESPERADAFATURAMENTO = "10,000";

        //Efetivos Faturamento
        String QTDEFETIVOFATU = "20";
        String QTDVENDAVISTA = "0";
        String QTDATUAL = "10";

        loginFlows.efetuarLogin();
        efetivosFlows.acessaMedicao(UNIDADE, DTEFETIVOS);
        efetivosFlows.informaEfetivosPla(QTDCLIENTE, QTDFUNCIONARIO,QTDDOACAO);
        efetivosFlows.informaEfetivosFatu(QTDEFETIVOFATU,QTDVENDAVISTA,QTDATUAL);

        Assert.assertEquals(efetivosFlows.retornaEfetivosCliente(),QTDESPERADACLIENTE,"Efetivos Clientes: ");
        Assert.assertEquals(efetivosFlows.retornaEfetivosFuncionario(),QTDESPERADAFUNCIONARIO,"Efetivos Funcionários: ");
        Assert.assertEquals(efetivosFlows.retornaEfetivosDoacao(),QTDESPERADADOACAO,"Efetivos Doação: ");
        Assert.assertEquals(efetivosFlows.retornaTotalEfetivos(),TOTEFET,"Efetivos Total Efetivos: ");
        Assert.assertEquals(efetivosFlows.retornaEfetivosFaturamento(),QTDESPERADAFATURAMENTO,"Efetivos Faturamento: ");

    }

    public void emitirRelatorio(String NMRELATORIO){
        loginFlows = new LoginFlows();
        efetivosFlows = new MedicaoEfetivosFlows();
        String UNIDADE = "0002";
        String DTINI = "01/10/2023";
        String DTFIM = "30/10/2023";
        String DTEFETIVOS = "19/10/2023";
        loginFlows.efetuarLogin();
        efetivosFlows.acessaMedicao(UNIDADE, DTEFETIVOS);
        efetivosFlows.selecionaRelatorio(NMRELATORIO);
        efetivosFlows.filtrarUnidade(UNIDADE);
        efetivosFlows.definirPeriodoRelatorio(DTINI,DTFIM);

    }


    @Test
    public void relatorioConhecimentoDoFornecimentoDeRefeicoesRFC(){
        String nomeRelatorio = "Conhecimento do Fornecimento de Refeições (R.F.C.)";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioMedicaoEfetivosPorServico(){
        String nomeRelatorio = "Medição de Efetivos por Serviço";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioMedicaoEfetivosPorData(){
        String nomeRelatorio = "Medição de Efetivos por Data";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioMedicaoEfetivosPorPratoPorServico(){
        String nomeRelatorio = "Medição de Efetivos por Prato (por Serviço)";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioMedicaoEfetivosPorPratoPorData(){
        String nomeRelatorio = "Medição de Efetivos por Prato (por Data)";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioMedicaoEfetivosPorPratoPorDataPrato(){
        String nomeRelatorio = "Medição de Efetivos por Prato (por Data / Prato)";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioMedicaoEfetivosPorPratoPorPratoData(){
        String nomeRelatorio = "Medição de Efetivos por Prato (por Prato / Data)";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioLogAlteracaoEfetivos(){
        String nomeRelatorio = "Log de Alteração de Efetivos";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void relatorioCFRSintetico(){
        String nomeRelatorio = "Conhecimento do Fornecimento de Refeições (Sintético)";
        emitirRelatorio(nomeRelatorio);
    }

    @Test
    public void zerarQuantidades(){
        String UNIDADE = "0002";
        String DTEFETIVOS = "19/10/2023";
        loginFlows = new LoginFlows();
        efetivosFlows = new MedicaoEfetivosFlows();
        loginFlows.efetuarLogin();
        efetivosFlows.acessaMedicao(UNIDADE, DTEFETIVOS);
        efetivosFlows.zerarQuantidadeEfetivos();
        Assert.assertEquals(efetivosFlows.retornaEfetivosCliente(),"0,00000","Efetivos Clientes: ");
        Assert.assertEquals(efetivosFlows.retornaEfetivosFuncionario(),"0,00000","Efetivos Funcionários: ");
        Assert.assertEquals(efetivosFlows.retornaEfetivosDoacao(),"0,00000","Efetivos Doação: ");
        Assert.assertEquals(efetivosFlows.retornaTotalEfetivos(),"0,000","Efetivos Total Efetivos: ");
        Assert.assertEquals(efetivosFlows.retornaEfetivosFaturamento(),"0,000","Efetivos Faturamento: ");

    }



}
