package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.OpcoesProdutosReceitaFlows;
import com.javaseleniumtemplate.pages.OpcoesProdutosReceitaPage;
import org.testng.annotations.Test;

public class OpcoesProdutosReceitaTests extends TestBase {

    OpcoesProdutosReceitaPage opcoesProdutosReceitaPage;
    OpcoesProdutosReceitaFlows opcoesProdutosReceitaFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Opções de Produtos na Receita'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar por OLEO DE GIRASSOL, selecionar o produto OLEO DE GIRASSOL, clicar em salvar
    //na aba produtos opcionais, verificar o código e o nome do produto apresentado
    //clicar na aba 'Produto Principal da Receita', verificar o código e nome do produto adicionado, clicar em voltar
    //procurar na tela inicial pelo código do produto adicionado, verificar o código e nome do produto encontrado
    //clicar no check-box do produto, clicar no botão excluir selecionados, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso, exibida no canto superior direito da tela
    //verificar a mensagem de nenhum registro encontrado, exibida no grid da lista de produtos
    @Test
    public void adicionarExcluirProdutoPrincipal() {
        opcoesProdutosReceitaPage = new OpcoesProdutosReceitaPage();
        opcoesProdutosReceitaFlows = new OpcoesProdutosReceitaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        opcoesProdutosReceitaFlows.navegaTelaOpcoesprodutosReceita();
        opcoesProdutosReceitaPage.adicionarProdutoPrincipal();
        opcoesProdutosReceitaPage.excluirProdutoPrincipal();
    }


    //acessar a tela 'Opções de Produtos na Receita'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto CARBONATO DE BARIO 500G que é um produto de compras
    //clicar no botão salvar, verificar a mensagem exibida na tela, clicar em ok e clicar em cancelar
    @Test
    public void tentarAdicionarProdutoDeCompras() {
        opcoesProdutosReceitaPage = new OpcoesProdutosReceitaPage();
        opcoesProdutosReceitaFlows = new OpcoesProdutosReceitaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        opcoesProdutosReceitaFlows.navegaTelaOpcoesprodutosReceita();
        opcoesProdutosReceitaPage.tentarAdicionarProdutoDeCompras();
    }


    //acessar a tela 'Opções de Produtos na Receita'
    //procurar pelo código 101110200700 no filtro inicial da tela
    //clicar no código do produto, clicar na aba 'produtos opcionais', clicar no botão adicionar, clicar no botão do campo produto
    //procurar pelo produto TARTARATO DE POTASSIO E ANTIMONIO e selecionar o mesmo
    //clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //na aba 'produto opcionais', verificar se o código e nome do produto opcional adicionado foram salvos corretamente
    //clicar no check-box do produto opcional adicionado, clicar no botão excluir selecionados, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar se o produto opcional foi excluído com sucesso e não está mais presente na tela
    @Test
    public void adicionarExcluirProdutoOpcional() {
        opcoesProdutosReceitaPage = new OpcoesProdutosReceitaPage();
        opcoesProdutosReceitaFlows = new OpcoesProdutosReceitaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        opcoesProdutosReceitaFlows.navegaTelaOpcoesprodutosReceita();
        opcoesProdutosReceitaPage.adicionarProdutoOpcional();
        opcoesProdutosReceitaPage.excluirProdutoOpcional();
    }


    //acessar a tela 'Opções de Produtos na Receita'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo código 101160200200 e selecionar o produto do mesmo
    //clicar em salvar, verificar a mensagem exibida na tela informando que o registro já existe, clicar em ok e clicar em cancelar
    //procurar pelo código 101160200200 no filtro inicial da tela
    //clicar no código do produto, clicar na aba 'produtos opcionais', clicar no botão adicionar, clicar no botão do campo produto
    //procurar pelo código 101310600300 e selecionar o produto do mesmo, clicar em salvar
    //verificar a mensagem exibida na tela informando que o produto opcional já foi cadastrado
    //clicar no botão ok, clicar no botão cancelar, clicar em voltar
    @Test
    public void tentarAdicionarProdutoJaCadastrado() {
        opcoesProdutosReceitaPage = new OpcoesProdutosReceitaPage();
        opcoesProdutosReceitaFlows = new OpcoesProdutosReceitaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        opcoesProdutosReceitaFlows.navegaTelaOpcoesprodutosReceita();
        opcoesProdutosReceitaPage.tentarAdicionarProdutoPrincipalJaExistente();
        opcoesProdutosReceitaPage.tentarAdicionarProdutoOpcionalJaExistente();
    }


    //acessar a tela 'Opções de Produtos na Receita'
    //clicar no botão adicionar, clicar em salvar, verificar mensagem de campo obrigatório no campo produto, clicar em cancelar
    //procurar pelo código 101110200700 no filtro inicial da tela
    //clicar no código do produto, clicar na aba 'produtos opcionais', clicar no botão adicionar, clicar em salvar
    //verificar mensagem de campo obrigatório no campo produto, clicar no botão cancelar em clicar em voltar
    @Test
    public void camposObrigatorios() {
        opcoesProdutosReceitaPage = new OpcoesProdutosReceitaPage();
        opcoesProdutosReceitaFlows = new OpcoesProdutosReceitaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        opcoesProdutosReceitaFlows.navegaTelaOpcoesprodutosReceita();
        opcoesProdutosReceitaPage.campoObrigatorioAddProdPrincipal();
        opcoesProdutosReceitaPage.campoObrigatorioAddProdOpcional();
    }


    //acessar a tela 'Opções de Produtos na Receita'
    //procurar pelo código 101310700800 no filtro inicial da tela
    //clicar no código do produto, clicar na aba 'produtos opcionais', clicar no código do produto opcional da primeira linha
    //clicar no botão excluir, verificar a mensagem exibida na tela informando que o produto opcional é equivalente ao produto principal e por isso não pode ser excluído
    //clicar no botão ok, clicar em voltar, clicar em voltar
    @Test
    public void tentarExcluirProdutoOpcionalIgualPrincipal() {
        opcoesProdutosReceitaPage = new OpcoesProdutosReceitaPage();
        opcoesProdutosReceitaFlows = new OpcoesProdutosReceitaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        opcoesProdutosReceitaFlows.navegaTelaOpcoesprodutosReceita();
        opcoesProdutosReceitaPage.tentarExcluirProdutoEquivalenteIgualPrincipal();
    }


}
